virtualenv --system-site-packages env
virtualenv env
source env/bin/activate

numpy & scipy
=============

http://www.scipy.org/

pip install numpy
pip install scipy


pyslalib
========

https://github.com/scottransom/pyslalib


mpfit
=====

https://code.google.com/p/astrolibpy/downloads/list

ppgplot
=======

https://code.google.com/p/ppgplot/

p_cfitsio
=========
Custom swig wrapper of the cfitsio library, need the libcfitsio3-dev package

! """
! DES: module collecting f90 subroutines for sky noise subtraction:
! """ 
!=============================================================================
SUBROUTINE correlatedNoise(CNoise, data, dataFlag, chanList, boloWeight, FFCF, clip, nInt, nChan, nChanlist)
! """
! DES: compute correlated noise
! INP: 
!      data     : entire data array
!      dataFlag : corresponding flag array
!      chanList : indexes of channel where we want to compute the cn (0 indexed)
!      Weight   : weight matrix 
!      FFCF     : flat field correction factors
!      clip     : sigma clipping factor (5 or so)
!      nInt     : nb. integ.
!      nChan    : nb. channels
!  nChanList    : nb. of channel to compute
!
! OUT: CNoise   : correlated noise
!
! """
! 20070421FB fixed some errors 
!
!-----------------------------------
!INOUT
  integer                             :: nInt, nChan, nChanList
  real,    dimension(nInt,nChan)      :: data, CNoise
  integer, dimension(nInt,nChan)      :: dataFlag
  integer, dimension(nChanList)       :: chanList 
  real,    dimension(nChan,nChan)     :: boloWeight,FFCF
  real                                :: clip
  !f2py intent(hide),depend(data)     :: nInt=shape(data,0),nChan=shape(data,1)
  !f2py inten(hide), depend(chanList) :: nChanList = shape(chanList)
  !f2py intent(in)                    :: data,dataFlag,chanList,boloWeight,FFCF,clip
  !f2py intent(out)                   :: CNoise
!-----------------------------------
  integer                             :: iChan, chanIndex, count1, count2
  integer, allocatable, dimension(:)  :: nGood
  real,    allocatable, dimension(:)  :: mean, rms
  real,    allocatable,dimension(:,:) :: res,subWeight
  logical, allocatable,dimension(:,:) :: flag_mask, flag_mask_chan
!-----------------------------------

ALLOCATE(flag_mask(nInt,nChan))

! first flag all the channels false, i.e. bad
flag_mask = .false.
! ... then unflag the channels in ChanList ...
DO iChan=1, nChanList
   ! index in the data/flag array (remember fortran indexing)
   flag_mask(:,chanList(iChan) + 1) = .true.   ! is good data
END DO

! ... and finally get the unflag data only
flag_mask = flag_mask .and. (dataFlag.eq.0)

! Number of good channel vs time
ALLOCATE(nGood(nInt))
nGood= MAX(1,COUNT(flag_mask,DIM=2))

! compute mean and rms along channel dimension
! ie mean and rms of all the bolo vs time
! Variance: Numerically-stable "two-pass" formula, which offers less
!           round-off error. Page 613, Numerical Recipes in C.

ALLOCATE(mean(nInt),rms(nInt))
ALLOCATE(res(nInt,nChan))

mean = SUM(data,MASK=flag_mask,DIM=2)/nGood
res  = data-SPREAD(mean,DIM=2,NCOPIES=nChan)
!rms  = clip*SQRT(SUM(res*res,MASK=flag_mask,DIM=2)-SUM(res,MASK=flag_mask,DIM=2)**2/nGood) / (nGood-1) ! wrong
rms  = clip*SQRT((SUM(res*res,MASK=flag_mask,DIM=2)-(SUM(res,MASK=flag_mask,DIM=2)**2/nGood))/real(nGood-1))

DEALLOCATE(res,nGood)

! add sigma clipping to mask --- I am not sure this is correct yet. Seems to clip too many points.
! thus i keep output. maybe someone else can look at this in a quiet minute/hour (FB)
count1 = COUNT(flag_mask)
flag_mask = flag_mask .and. (ABS(data-SPREAD(mean,DIM=2,NCOPIES=nChan)).le.SPREAD(rms,DIM=2,NCOPIES=nChan))
count2 = COUNT(flag_mask)
write(*,'("clip ",i10," of ",i10,$)') count1-count2,count1

DEALLOCATE(mean,rms)
ALLOCATE(flag_mask_chan(nInt,nChan))
ALLOCATE(subWeight(nInt,nChan))

DO iChan=1, nChanList
!DO iChan=1, 1

   chanIndex = chanList(iChan)+1

   flag_mask_chan = flag_mask
   flag_mask_chan(:,chanIndex)=.false.

   ! FFCF are FF correction factors with respect to channel in first index
   subWeight = SPREAD(boloWeight(chanIndex,:)*FFCF(chanIndex,:),DIM=1,NCOPIES=nInt)

   write(*,'(i4,$)') chanIndex
!   print*,flag_mask_chan(100,:)
!   print*,' ' 
!   print*,subWeight(100,:)
!   print*,' ' 
!   print*,data(100,:)

   ! multiply weights into data and sum:
   CNoise(:,chanIndex) = SUM(data * subWeight,MASK=flag_mask_chan,DIM=2)

!   print*,' ' 
!   print*,CNoise(1:120,chanIndex)

   ! normalize by the weight - not by flatfield!
   ! CNoise(:,chanIndex)=CNoise(:,chanIndex)/SUM(subWeight,MASK=flag_mask_chan,DIM=2)
   subWeight = SPREAD(boloWeight(chanIndex,:),DIM=1,NCOPIES=nInt)
   CNoise(:,chanIndex)=CNoise(:,chanIndex)/SUM(subWeight,MASK=flag_mask_chan,DIM=2)

ENDDO
print*,' '
 
DEALLOCATE(subWeight,flag_mask,flag_mask_chan)  

RETURN
END SUBROUTINE correlatedNoise

!=============================================================================
SUBROUTINE cmatrix(data,flag,chanList,ccmatrix,nInt,nChan,nChanList)
! """
! DES: compute correlation matrix of an array over a sub sample of chanList
! INP: data      : entire data array
!      flag      : entire flag array
!      chanList  : the indexes used to compute the correlation
!      nInt      : nb. integ.
!      nChan     : nb. channels
!      nChanList : nb. indexes
! OUT: ccmatrix (nChan,nChan) = correlation matrix
! """
!-----------------------------------
!INOUT
  integer                             :: nInt,nChan
  real,    dimension(nInt,nChan)      :: data
  integer, dimension(nInt,nChan)      :: flag
  real,    dimension(nChan,nChan)     :: ccmatrix
  integer, dimension(nChanList)       :: chanList
  !f2py intent(hide),depend(data)     :: nInt=shape(data,0),nChan=shape(data,1)
  !f2py intent(hide),depend(chanList) :: nChanList = shape(chanList)
  !f2py intent(in)                    :: data,flag,chanList
  !f2py intent(out)                   :: ccmatrix
!-----------------------------------
!LOCAL
  integer                             :: iChan1, iChan2, indexChan1, indexChan2
  integer                             :: nGood, imax
  real                                :: sum1, sum2
  logical,dimension(nInt)             :: flag_mask
  real,allocatable,dimension(:)       :: arr1,arr2
!-----------------------------------

! initialize the matrix with NaN
ccmatrix = -1
ccmatrix = sqrt(ccmatrix)

DO iChan1=1,nChanList
   indexChan1 = chanList(iChan1)+1
   DO iChan2=iChan1,nChanList
      indexChan2 = chanList(iChan2)+1

      ! test for non flagged data in both chan1 and chan2
      flag_mask  = (flag(:,indexChan1).eq.0).and.(flag(:,indexChan2).eq.0)
      nGood = COUNT(flag_mask)

      ! we need at least 2 numbers to compute a correlation coefficient
      if(nGood>1) then
         
         ! extract common non flagged data from chan1 and chan2
         ALLOCATE(arr1(nGood),arr2(nGood))
         arr1 = PACK(data(:,indexChan1),MASK=flag_mask)
         arr2 = PACK(data(:,indexChan2),MASK=flag_mask)

         ! more accurate formula :
         ! http://mathworld.wolfram.com/CorrelationCoefficient.html
         sum1 = sum(arr1)
         sum2 = sum(arr2)
         cc = (nGood*sum(arr1*arr2)-sum1*sum2) /  &
              &sqrt((nGood*sum(arr1*arr1)-sum1**2)*(nGood*sum(arr2*arr2)-sum2**2))
         
         ccmatrix(indexChan1,indexChan2) = cc
         ccmatrix(indexChan2,indexChan1) = cc
         DEALLOCATE(arr1,arr2)
      ENDIF
   END DO
END DO

END SUBROUTINE cmatrix

!=============================================================================
SUBROUTINE wmatrix(ccmatrix, chanSep, chanList, minCorr, a, b, core, beta, wwmatrix, nChan, nChanList)
! """
! DES: compute the weight matrix, a non linear rescaling of the correlation matrix
! INP: ccmatrix  : the correlation matrix
!      chanSep   : the channel separation in arcsec
!      minCorr   : cut of value for the correlation
!      a,b       : coefficient for the rescaling ( wmatrix_nm = ( cmatrix_nm - a * min_m( cmatrix_nm ) )**b )
!      core,beta : additional coefficient for rescaling ( weight_nm  = weight_nm * 1.0 / ( 1 + ( dist_nm / core(in arcmin) )**beta ) )
!      chanList  : the indexes used to compute the correlation
!      nChan     : nb. channels
!      nChanList : nb. indexes
! OUT: wwmatrix (nChan,nChan) = weight matrix
! """
!-----------------------------------
!INOUT
  integer                             :: nChan, nChanList
  real,    dimension(nChan,nChan)     :: ccmatrix, wwmatrix, chanSep
  integer, dimension(nChanList)       :: chanList
  real                                :: minCorr,a,b, core, beta
  !f2py intent(hide),depend(ccmatrix) :: nChan=shape(ccmatrix,0)
  !f2py intent(hide),depend(chanList) :: nChanList = shape(chanList)
  !f2py intent(in)                    :: ccmatrix, chanSep, chanList, minCorr, a, b
  !f2py intent(out)                   :: wwmatrix
!-----------------------------------
!LOCAL
  integer                             :: iChan1, iChan2, indexChan1, indexChan2
  integer                             :: mask_count
  real, dimension(:), allocatable     :: aMinCorr
  logical, dimension(nChan,nChan)     :: flag_mask
  logical, dimension(nChan)           :: min_flag_mask
!-----------------------------------
! first flag all the channels...
flag_mask = .false.
! ... then unflag the channels in ChanList ...

DO iChan1=1, nChanList
   indexChan1 = chanList(iChan1)+1
   DO iChan2=iChan1,nChanList
      indexChan2 = chanList(iChan2)+1
      ! index in the data/flag array (remember fortran indexing)
      flag_mask(indexChan1,indexChan2) = .true.
      flag_mask(indexChan2,indexChan1) = .true.
   END DO
END DO

wwmatrix(:,1)  = MINVAL(ccmatrix,DIM=2,MASK=flag_mask)  ! will return largest possible number is MASK=.false.
min_flag_mask  = wwmatrix(:,1).lt.minCorr               ! check where minimum is < minCorr
mask_count     = COUNT(min_flag_mask)

IF (mask_count>1) THEN                                  ! limit minimum to minCorr
   allocate(aMinCorr(mask_count))
   aMinCorr = minCorr
   wwmatrix(:,1) = UNPACK(aMinCorr,MASK=min_flag_mask,FIELD=wwmatrix(:,1))
   deallocate(aMinCorr)
ENDIF

wwmatrix = (ccmatrix-SPREAD(a*wwmatrix(:,1),DIM=2,NCOPIES=nChan))**b   ! spread the weights

IF (core > 0) THEN 
   wwmatrix = wwmatrix * 1.0 / ( 1. +( ChanSep/60. / core )**beta )       ! taper with beta profile
ENDIF
IF (core < 0) THEN 
   wwmatrix = wwmatrix * (1.0 - (1.0 / ( 1. +( ChanSep/60. / (-core) )**beta )))  ! 1 - beta profile
ENDIF

END SUBROUTINE

!=============================================================================
subroutine correlationFit(correlateFrom, correlateTo, flag, chanList, minMaxSlope, slope, intercep, FFCF, nInt,nChan,nChanList)
! """
! DES: order-1 (linear) fit to data vs. data2
!      Produces fit coefficients and fit array matching the data (including
!      the flagged!).
! INP: correlateFrom  : data or skynoise array
!      correlateTo    : data
!      flag           : corresponding flag array
!    chanList         : indexes of channel where we want to compute the fit (0 indexed)
!      nInt           : nb. integ.
!      nChan          : nb. channels
!  nChanList          : nb. of channel to compute
!
! OUT: slope          : slopes of linear fit   (nChanList x nChanList)
!     intercep        : intercep of linear fit (nChanList x nChanList)
!      FFCF           : Flat field correction factor
! """

!INOUT ----------------------------
  integer                                  :: nInt, nChan, nChanList
  real,    dimension(nInt,nChan)           :: correlateFrom, correlateTo
  integer, dimension(nInt,nChan)           :: flag
  real,    dimension(nChanList,nChanList)  :: slope, intercep
  integer, dimension(nChanList)            :: chanList 
  real,    dimension(nChan,nChan)          :: FFCF
  real,    dimension(2)                    :: minMaxSlope
  !f2py intent(hide),depend(correlateFrom) :: nInt=shape(correlateFrom,0),nChan=shape(correlateFrom,1)
  !f2py intent(hide),depend(chanList)      :: nChanList=shape(chanList)
  !f2py intent(in)                         :: data, flag, chanList, minMaxSlope
  !f2py intent(out,hide)                   :: slope, intercep, FFCF
!LOCAL ---------------------------- 
  integer                                  :: iChannel, index, indexRef, nGood
  real                                     :: chisq, iSlope, iIntercep
  logical, dimension(nInt)                 :: flag_mask
  real,allocatable,dimension(:)            :: x,y
! ---------------------------------

! Initialize the Flat Field
FFCF = 0

! loop through the requested channels
DO iRefChannel=1, nChanList
   ! index in the data/flag array (remember fortran indexing)
   indexRef = chanList(iRefChannel) + 1

   DO iChannel=iRefChannel, nChanList
      ! index in the data/flag array (remember fortran indexing)
      index = chanList(iChannel) + 1
      
      ! find the non flagged value
      flag_mask = (flag(:,indexRef).eq.0).and.(flag(:,index).eq.0)
      nGood = COUNT(flag_mask)
      
      if(nGood>1) then
     
         ! Extract the non flagged data
         ALLOCATE( x(nGood), y(nGood) )

         x = PACK(correlateFrom(:,indexRef) ,MASK=flag_mask) 
         y = PACK(  correlateTo(:,index),    MASK=flag_mask)
         
         call fit(x,y,iIntercep,iSlope,nGood)

         intercep(iRefChannel, iChannel) = iIntercep
         if(iChannel.ne.iRefChannel) intercep(iChannel, iRefChannel) = -1.0*iIntercep/iSlope
!         if(iChannel.ne.iRefChannel) intercep(iChannel, iRefChannel) = iIntercep

         slope(iRefChannel, iChannel)    = iSlope
         if(iChannel.ne.iRefChannel) slope(iChannel, iRefChannel)    = 1./iSlope
!         if(iChannel.ne.iRefChannel) slope(iChannel, iRefChannel)    = iSlope

         FFCF(indexRef, index)           = iSlope
         if(index.ne.indexRef) FFCF(index, indexRef)           = 1./iSlope

         DEALLOCATE(x,y)
         
      END IF
   END DO
END DO

! Saturate the FFCF and inverse

WHERE( FFCF.ge.maxval(minMaxSlope) ) FFCF = maxval(minMaxSlope)
WHERE( FFCF.le.minval(minMaxSlope) ) FFCF = minval(minMaxSlope)

! Array filled with NaN for non computed channels... 
! Diagnostic tools for further routines which should not use them

FFCF = 1./FFCF

! FFCF is NOT normalized at this point...

END SUBROUTINE correlationFit


SUBROUTINE principalComponentAnalysis(data, nComp, dataBack, nx,ny)
!
! Do not use yet
!

integer                   :: nx, ny, nComp
real, dimension(nx,ny)    :: data, dataBack

!f2py intent(hide),depend(data)  :: nx=shape(data,0),ny=shape(data,1)
!f2py intent(in)                 :: data,nComp
!f2py intent(out)                :: dataBack

real, dimension(ny)       :: mean
real, dimension(nx,ny)    :: adjustedData
real, dimension(nx,nComp) :: finalData

real, dimension(nComp,ny)           :: desiredFeature
double precision, dimension(ny,ny)  :: eigenVectors
double precision, dimension(ny)     :: eigenValues
double precision, dimension(3*ny-1) :: work
integer                             :: info

mean = SUM(data, DIM=1)/nX
adjustedData = data-SPREAD(mean,DIM=1,NCOPIES=nX)

! fill eigenvectors matrix with covariance matrix
eigenVectors = MATMUL(transpose(adjustedData),adjustedData)/(nY+1)

CALL DSYEV('V','U',ny,eigenVectors,ny,eigenvalues,work,3*ny-1,info)

print *,info
desiredFeature = eigenVectors(1:nComp,:)

finalData = MATMUL(adjustedData,transpose(desiredFeature))
dataBack  = MATMUL(finalData,desiredFeature)+SPREAD(mean,DIM=1,NCOPIES=nX)

END SUBROUTINE principalComponentAnalysis

!"""
!NAM: fFlagHandler.f90 (file)
!DES: Contains modules with subroutines for fast bitwise manipulation of flags.
!     Throughout the file, the nomenclature is as follows:
!
!     - aFlags(n_aFlags):
!       The flag array to be manipulated or queried.
!
!       Permitted shapes and datatypes of aFlags depend on the
!       the module
!
!     - bitmask:
!       Specifies the flag values used for manipulating or queriing the flag array.
!
!       The datatype corresponds to the datatype of aFlags and depends on the module.
!"""
module flags1d32b
!"""
!NAM: flags1d32b (module)
!DES: Bitwise manipulation of 1-dim flag arrays of type integer*4
!"""
contains
  subroutine setAll(aFlags, bitmask, n_aFlags)
    !"""
    !NAM: flags1d32b.setAll (Subroutine)
    !DES: Sets the flag values specified by bitmask for all elements of aFlags
    !INP: aFlags (integer*4(n_aFlags)) : Flag array
    !     bitmask (integer*4)          : Specifies the flag values
    !"""
    integer*4                                   :: n_aFlags
    integer*4, dimension(n_aFlags)              :: aFlags
    integer*4                                   :: bitmask
    !f2py integer*4 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags = len(aFlags)

    aFlags = ior(aFlags, bitmask)
  end subroutine setAll

  subroutine unsetAll(aFlags, bitmask, n_aFlags)
    !"""
    !NAM: flags1d32b.unsetAll (Subroutine)
    !DES: Unsets the flag values specified by bitmask for all elements of aFlags
    !INP: aFlags (integer*4(n_aFlags)) : Flag array
    !     bitmask (integer*4)          : Specifies the flag values
    !"""
    integer*4                                   :: n_aFlags
    integer*4, dimension(n_aFlags)              :: aFlags
    integer*4                                   :: bitmask
    !f2py integer*4 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags = len(aFlags)

    aFlags = iand(aFlags, not(bitmask))
  end subroutine unsetAll

  subroutine nSet(aFlags, bitmask, n_aFlags, countSet)
    !"""
    !NAM: flags1d32b.nSet (Subroutine)
    !DES: Returns the number of elements of aFlags for which
    !     at least one flag value specified by bitmask is set.
    !INP: aFlags (integer*4(n_aFlags)) : Flag array
    !     bitmask (integer*4)          : Specifies the flag values
    !OUT: countSet(integer*4)          : Number of elements of aFlags for which at least
    !                                    one flag value specified by bitmask is set.
    !"""
    integer*4                                   :: n_aFlags
    integer*4, dimension(n_aFlags)              :: aFlags
    integer*4                                   :: bitmask
    integer*4                                   :: countSet
    !f2py integer*4 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags = len(aFlags)
    !f2py integer*4 intent(out)                 :: countSet

    countSet = count( iand(aFlags, bitmask) /= 0 )
  end subroutine nSet

  subroutine nUnset(aFlags, bitmask, n_aFlags, countUnset)
    !"""
    !NAM: flags1d32b.nUnset (Subroutine)
    !DES: Returns the number of elements of aFlags for which
    !     none of the flag values specified by bitmask is set.
    !INP: aFlags (integer*4(n_aFlags)) : Flag array
    !     bitmask (integer*4)          : Specifies the flag values
    !OUT: countUnset(integer*4)        : Number of elements of aFlags for which none of
    !                                    the flag values specified by bitmask is set.
    !"""
    integer*4                                   :: n_aFlags
    integer*4, dimension(n_aFlags)              :: aFlags
    integer*4                                   :: bitmask
    integer*4                                   :: countUnset
    !f2py integer*4 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags = len(aFlags)
    !f2py integer*4 intent(out)                 :: countUnset

    countUnset = count( iand(aFlags, bitmask) == 0 )
  end subroutine nUnset

  subroutine setOnIndex(aFlags, index, bitmask, n_aFlags)
    !"""
    !NAM: flags1d32b.setOnIndex (Subroutine)
    !DES: Sets the flag values specified by bitmask for a single element of
    !     the flag array aFlags
    !INP: aFlags (integer*4(n_aFlags)) : Flag array
    !     index (integer*4)            : Index of the element of aFlags to be set
    !     bitmask (integer*4)          : Specifies the flag values
    !"""
    integer*4                                   :: n_aFlags
    integer*4, dimension(n_aFlags)              :: aFlags
    integer*4                                   :: index
    integer*4                                   :: bitmask
    !f2py integer*4 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags = len(aFlags)

    aFlags(index) = ior(aFlags(index), bitmask)
  end subroutine setOnIndex

  subroutine unsetOnIndex(aFlags, index, bitmask, n_aFlags)
    !"""
    !NAM: flags1d32b.unsetOnIndex (Subroutine)
    !DES: Unsets the flag values specified by bitmask for a single element of
    !     the flag array aFlags
    !INP: aFlags (integer*4(n_aFlags)) : Flag array
    !     index (integer*4)            : Index of the element of aFlags to be unset
    !     bitmask (integer*4)          : Specifies the flag values
    !"""
    integer*4                                   :: n_aFlags
    integer*4, dimension(n_aFlags)              :: aFlags
    integer*4                                   :: index
    integer*4                                   :: bitmask
    !f2py integer*4 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags = len(aFlags)

    aFlags(index) = iand(aFlags(index), not(bitmask))
  end subroutine unsetOnIndex

  subroutine isSetOnIndex(aFlags, index, bitmask, n_aFlags, isSet)
    !"""
    !NAM: flags1d32b.isSetOnIndex (Subroutine)
    !DES: Returns 1 if at least one flag value specified by bitmask
    !     is set for a single element of flag array aFlags.
    !INP: aFlags (integer*4(n_aFlags)) : Flag array
    !     index (integer*4)            : Index of the element of aFlags to be unset
    !     bitmask (integer*4)          : Specifies the flag values
    !OUT: isSet (integer*1)            : 1 if at least one flag value specified by bitmask
    !                                    is set, 0 else.
    !"""
    integer*4                                   :: n_aFlags
    integer*4, dimension(n_aFlags)              :: aFlags
    integer*4                                   :: index
    integer*4                                   :: bitmask
    integer*1                                   :: isSet
    !f2py integer*4 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags = len(aFlags)
    !f2py integer*1 intent(out)                 :: isSet

    if (iand(aFlags(index), bitmask) /= 0) then
       isSet = 1
    else
       isSet = 0
    end if
  end subroutine isSetOnIndex

  subroutine isUnsetOnIndex(aFlags, index, bitmask, n_aFlags, isUnset)
    !"""
    !NAM: flags1d32b.isUnsetOnIndex (Subroutine)
    !DES: Returns 1 if none of the flag values specified by bitmask
    !     is set for a single element of flag array aFlags.
    !INP: aFlags (integer*4(n_aFlags)) : Flag array
    !     index (integer*4)            : Index of the element of aFlags to be unset
    !     bitmask (integer*4)          : Specifies the flag values
    !OUT: isUnset (integer*1)          : 1 if none of the flag values specified by bitmask
    !                                    is set, 0 else.
    !"""
    integer*4                                   :: n_aFlags
    integer*4, dimension(n_aFlags)              :: aFlags
    integer*4                                   :: index
    integer*4                                   :: bitmask
    integer*1                                   :: isUnset
    !f2py integer*4 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags = len(aFlags)
    !f2py integer*1 intent(out)                 :: isUnset

    if (iand(aFlags(index), bitmask) /= 0) then
       isUnset = 0
    else
       isUnset = 1
    end if
  end subroutine isUnsetOnIndex

  subroutine setOnMask(aFlags, aMask, bitmask, n_aFlags)
    !"""
    !NAM: flags1d32b.setOnMask (Subroutine)
    !DES: Sets the flag values specified by bitmask for all elements of
    !     the flag array aFlags specified by aMask
    !INP: aFlags (integer*4(n_aFlags)) : Flag array
    !     aMask (integer*1(n_aFlags))  : Mask specifiing teh elements of
    !                                    aFlags to be manipulated.
    !     index (integer*4)            : Index of the element of aFlags to be set
    !     bitmask (integer*4)          : Specifies the flag values
    !"""
    integer*4                                   :: n_aFlags
    integer*4, dimension(n_aFlags)              :: aFlags
    integer*1, dimension(n_aFlags)              :: aMask
    integer*4                                   :: bitmask
    !f2py integer*4 intent(inplace)             :: aFlags
    !f2py integer*1 intent(in)                  :: aMask
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags = len(aFlags)

    where( aMask /= 0 )
       aFlags = ior(aFlags, bitmask)
    end where
  end subroutine setOnMask

  subroutine unsetOnMask(aFlags, aMask, bitmask, n_aFlags)
    !"""
    !NAM: flags1d32b.unsetOnMask (Subroutine)
    !DES: Unsets the flag values specified by bitmask for all elements of
    !     the flag array aFlags specified by aMask
    !INP: aFlags (integer*4(n_aFlags)) : Flag array
    !     aMask (integer*1(n_aFlags))  : Mask specifiing teh elements of
    !                                    aFlags to be manipulated.
    !     index (integer*4)            : Index of the element of aFlags to be set
    !     bitmask (integer*4)          : Specifies the flag values
    !"""
    integer*4                                   :: n_aFlags
    integer*4, dimension(n_aFlags)              :: aFlags
    integer*1, dimension(n_aFlags)              :: aMask
    integer*4                                   :: bitmask
    !f2py integer*4 intent(inplace)             :: aFlags
    !f2py integer*1 intent(in)                  :: aMask
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags = len(aFlags)

    where( aMask /= 0 )
       aFlags = iand(aFlags, not(bitmask))
    end where
  end subroutine unsetOnMask

  subroutine isSetMask(aFlags, bitmask, n_aFlags, aMask)
    !"""
    !NAM: flags1d32b.isSetMask (Subroutine)
    !DES: Returns a mask that indicates for which elements
    !     of aFlags at least one of the flag values specified by
    !     bitmask is set.
    !INP: aFlags (integer*4(n_aFlags)) : Flag array
    !     bitmask (integer*4)          : Specifies the flag values
    !OUT: aMask (integer*1(n_aFlags))  : Mask indicating that at least one of the flag values
    !                                    specified by bitmask is set for the corresponding
    !                                    element of aFlags.
    !"""
    integer*4                                   :: n_aFlags
    integer*4, dimension(n_aFlags)              :: aFlags
    integer*4                                   :: bitmask
    integer*1, dimension(n_aFlags)              :: aMask
    !f2py integer*4 intent(in)                  :: aFlags
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags = len(aFlags)
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py intent(out)                           :: aMask

    aMask = (iand(aFlags, bitmask) /= 0)
    ! Necessary since conversion from logical to integer*1 may yield -1
    aMask = abs(aMask)
  end subroutine isSetMask

  subroutine isUnsetMask(aFlags, bitmask, n_aFlags, aMask)
    !"""
    !NAM: flags1d32b.isUnsetMask (Subroutine)
    !DES: Returns a mask that indicates for which elements
    !     of aFlags none of the flag values specified by
    !     bitmask is set.
    !INP: aFlags (integer*4(n_aFlags)) : Flag array
    !     bitmask (integer*4)          : Specifies the flag values
    !OUT: aMask (integer*1(n_aFlags))  : Mask indicating that none of the flag values
    !                                    specified by bitmask is set for the corresponding
    !                                    element of aFlags.
    !"""
    integer*4                                   :: n_aFlags
    integer*4, dimension(n_aFlags)              :: aFlags
    integer*4                                   :: bitmask
    integer*1, dimension(n_aFlags)              :: aMask
    !f2py integer*4 intent(in)                  :: aFlags
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags = len(aFlags)
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py intent(out)                           :: aMask

    aMask = (iand(aFlags, bitmask) == 0)
    ! Necessary since conversion from logical to integer*1 may yield -1
    aMask = abs(aMask)
  end subroutine isUnsetMask

end module flags1d32b

module flags2d8b
!"""
!NAM: flags1d32b (module)
!DES: Bitwise manipulation of 1-dim flag arrays of type integer*4
!"""
contains
  subroutine setAll(aFlags, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.setAll (Subroutine)
    !DES: Sets the flag values specified by bitmask for all elements of aFlags
    !INP: aFlags (integer*1(n_aFlags1, n_aFlags2)) : Flag array
    !     bitmask (integer*1)          : Specifies the flag values
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    aFlags = ior(aFlags, bitmask)
  end subroutine setAll

  subroutine setAll1(aFlags, index, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.setAll1 (Subroutine)
    !DES: flags2d8b.setAll restricted to slice in dimension 1
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*4                                   :: index
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    aFlags(:,index) = ior(aFlags(:,index), bitmask)
  end subroutine setAll1

  subroutine setAll2(aFlags, index, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.setAll2 (Subroutine)
    !DES: flags2d8b.setAll restricted to slice in dimension 2
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*4                                   :: index
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    aFlags(index,:) = ior(aFlags(index,:), bitmask)
  end subroutine setAll2

  subroutine unsetAll(aFlags, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.unsetAll (Subroutine)
    !DES: Unsets the flag values specified by bitmask for all elements of aFlags
    !INP: aFlags (integer*1(n_aFlags)) : Flag array
    !     bitmask (integer*4)          : Specifies the flag values
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    aFlags = iand(aFlags, not(bitmask))
  end subroutine unsetAll

  subroutine unsetAll1(aFlags, index, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.unsetAll1 (Subroutine)
    !DES: flags2d8b.unsetAll restricted to slice in dimension 1
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*4                                   :: index
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    aFlags(:,index) = iand(aFlags(:,index), not(bitmask))
  end subroutine unsetAll1

  subroutine unsetAll2(aFlags, index, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.unsetAll1 (Subroutine)
    !DES: flags2d8b.unsetAll restricted to slice in dimension 1
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*4                                   :: index
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    aFlags(index,:) = iand(aFlags(index,:), not(bitmask))
  end subroutine unsetAll2

  subroutine nSet(aFlags, bitmask, n_aFlags1, n_aFlags2, countSet)
    !"""
    !NAM: flags2d8b.nSet (Subroutine)
    !DES: Returns the number of elements of aFlags for which
    !     at least one flag value specified by bitmask is set.
    !INP: aFlags (integer*1(n_aFlags1, n_aFlags2)) : Flag array
    !     bitmask (integer*1)          : Specifies the flag values
    !OUT: countSet(integer*4)          : Number of elements of aFlags for which at least
    !                                    one flag value specified by bitmask is set.
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*4                                   :: bitmask
    integer*4                                   :: countSet
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*4 intent(out)                 :: countSet

    countSet = count( iand(aFlags, bitmask) /= 0 )
  end subroutine nSet

  subroutine nSet1(aFlags, index, bitmask, n_aFlags1, n_aFlags2, countUnset)
    !"""
    !NAM: flags2d8b.nSet1 (Subroutine)
    !DES: flags2d8b.nSet restricted to slice in dimension 1
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*4                                   :: index
    integer*4                                   :: bitmask
    integer*4                                   :: countUnset
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*4 intent(out)                 :: countUnset

    countUnset = count( iand(aFlags(:,index), bitmask) /= 0 )
  end subroutine nSet1

  subroutine nSet2(aFlags, index, bitmask, n_aFlags1, n_aFlags2, countUnset)
    !"""
    !NAM: flags2d8b.nSet2 (Subroutine)
    !DES: flags2d8b.nSet restricted to slice in dimension 2
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*4                                   :: index
    integer*4                                   :: bitmask
    integer*4                                   :: countUnset
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*4 intent(out)                 :: countUnset

    countUnset = count( iand(aFlags(index,:), bitmask) /= 0 )
  end subroutine nSet2


  subroutine nUnset(aFlags, bitmask, n_aFlags1, n_aFlags2, countUnset)
    !"""
    !NAM: flags2d8b.nUnset (Subroutine)
    !DES: Returns the number of elements of aFlags for which
    !     none of the flag values specified by bitmask is set.
    !INP: aFlags (integer*1(n_aFlags1, n_aFlags2)) : Flag array
    !     bitmask (integer*1)          : Specifies the flag values
    !OUT: countUnset(integer*4)        : Number of elements of aFlags for which none of
    !                                    the flag values specified by bitmask is set.
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*4                                   :: bitmask
    integer*4                                   :: countUnset
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*4 intent(out)                 :: countUnset

    countUnset = count( iand(aFlags, bitmask) == 0 )
  end subroutine nUnset

  subroutine nUnset1(aFlags, index, bitmask, n_aFlags1, n_aFlags2, countUnset)
    !"""
    !NAM: flags2d8b.nUnset1 (Subroutine)
    !DES: flags2d8b.nUnset restricted to slice in dimension 1
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*4                                   :: index
    integer*4                                   :: bitmask
    integer*4                                   :: countUnset
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*4 intent(out)                 :: countUnset

    countUnset = count( iand(aFlags(:,index), bitmask) == 0 )
  end subroutine nUnset1

  subroutine nUnset2(aFlags, index, bitmask, n_aFlags1, n_aFlags2, countUnset)
    !"""
    !NAM: flags2d8b.nUnset2 (Subroutine)
    !DES: flags2d8b.nUnset restricted to slice in dimension 2
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*4                                   :: index
    integer*4                                   :: bitmask
    integer*4                                   :: countUnset
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*4 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*4 intent(out)                 :: countUnset

    countUnset = count( iand(aFlags(index,:), bitmask) == 0 )
  end subroutine nUnset2

  subroutine setOnIndex(aFlags, index1, index2, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.setOnIndex (Subroutine)
    !DES: Sets the flag values specified by bitmask for a single element of
    !     the flag array aFlags
    !INP: aFlags (integer*1(n_aFlags1, n_aFlags2)) : Flag array
    !     index1, index2 (integer*4)   : Indices of the element of aFlags to be set
    !     bitmask (integer*1)          : Specifies the flag values
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*4                                   :: index1, index2
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index1, index2
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    aFlags(index1, index2) = ior(aFlags(index1, index2), bitmask)
  end subroutine setOnIndex

  subroutine unsetOnIndex(aFlags, index1, index2, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.unsetOnIndex (Subroutine)
    !DES: Unsets the flag values specified by bitmask for a single element of
    !     the flag array aFlags
    !INP: aFlags (integer*1(n_aFlags1, n_aFlags2)) : Flag array
    !     index1, index2 (integer*4)   : Indices of the element of aFlags to be set
    !     bitmask (integer*1)          : Specifies the flag values
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*4                                   :: index1, index2
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index1, index2
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    aFlags(index1, index2) = iand(aFlags(index1, index2), not(bitmask))
  end subroutine unsetOnIndex

  subroutine isSetOnIndex(aFlags, index1, index2, bitmask, n_aFlags1, n_aFlags2, isSet)
    !"""
    !NAM: flags2d8b.isSetOnIndex (Subroutine)
    !DES: Returns 1 if at least one flag value specified by bitmask
    !     is set for a single element of flag array aFlags.
    !INP: aFlags (integer*1(n_aFlags1, n_aFlags2)) : Flag array
    !     index1, index2 (integer*4)   : Indices of the element of aFlags to be set
    !     bitmask (integer*1)          : Specifies the flag values
    !OUT: isSet (integer*1)            : 1 if at least one flag value specified by bitmask
    !                                    is set, 0 else.
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*4                                   :: index1, index2
    integer*1                                   :: bitmask
    integer*1                                   :: isSet
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index1, index2
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*1 intent(out)                 :: isSet

    if (iand(aFlags(index1, index2), bitmask) /= 0) then
       isSet = 1
    else
       isSet = 0
    end if
  end subroutine isSetOnIndex

  subroutine isUnsetOnIndex(aFlags, index1, index2, bitmask, n_aFlags1, n_aFlags2, isUnset)
    !"""
    !NAM: flags2d8b.isUnsetOnIndex (Subroutine)
    !DES: Returns 1 if none of the flag values specified by bitmask
    !     is set for a single element of flag array aFlags.
    !INP: aFlags (integer*1(n_aFlags1, n_aFlags2)) : Flag array
    !     index1, index2 (integer*4)   : Indices of the element of aFlags to be set
    !     bitmask (integer*1)          : Specifies the flag values
    !OUT: isUnset (integer*1)          : 1 if none of the flag values specified by bitmask
    !                                    is set, 0 else.
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*4                                   :: index1, index2
    integer*1                                   :: bitmask
    integer*1                                   :: isUnset
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*4 intent(in)                  :: index1, index2
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*1 intent(out)                 :: isUnset

    if (iand(aFlags(index1, index2), bitmask) /= 0) then
       isUnset = 0
    else
       isUnset = 1
    end if
  end subroutine isUnsetOnIndex

  subroutine setOnMask(aFlags, aMask, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.setOnMask (Subroutine)
    !DES: Sets the flag values specified by bitmask for all elements of
    !     the flag array aFlags specified by aMask
    !INP: aFlags (integer*1(n_aFlags1, n_aFlags2)) : Flag array
    !     aMask (integer*1(n_aFlags1, n_aFlags2))  : Mask specifiing the elements of
    !                                    aFlags to be manipulated.
    !     bitmask (integer*1)          : Specifies the flag values
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aMask
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*1 intent(in)                  :: aMask
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    where( aMask /= 0 )
       aFlags = ior(aFlags, bitmask)
    end where
  end subroutine setOnMask

  subroutine setOnMask1(aFlags, aMask, index, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.setOnMask1 (Subroutine)
    !DES: flags2d8b.setOnMask restricted to slice in dimension 1
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1, dimension(n_aFlags1)             :: aMask
    integer*4                                   :: index
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*1 intent(in)                  :: aMask
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    where( aMask /= 0 )
       aFlags(:,index) = ior(aFlags(:,index), bitmask)
    end where
  end subroutine setOnMask1

  subroutine setOnMask2(aFlags, aMask, index, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.setOnMask2 (Subroutine)
    !DES: flags2d8b.setOnMask restricted to slice in dimension 2
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1, dimension(n_aFlags2)             :: aMask
    integer*4                                   :: index
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*1 intent(in)                  :: aMask
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    where( aMask /= 0 )
       aFlags(index,:) = ior(aFlags(index,:), bitmask)
    end where
  end subroutine setOnMask2

  subroutine unsetOnMask(aFlags, aMask, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.unsetOnMask (Subroutine)
    !DES: Unsets the flag values specified by bitmask for all elements of
    !     the flag array aFlags specified by aMask
    !INP: aFlags (integer*1(n_aFlags1, n_aFlags2)) : Flag array
    !     aMask (integer*1(n_aFlags1, n_aFlags2))  : Mask specifiing the elements of
    !                                    aFlags to be manipulated.
    !     bitmask (integer*1)          : Specifies the flag values
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aMask
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*1 intent(in)                  :: aMask
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    where( aMask /= 0 )
       aFlags = iand(aFlags, not(bitmask))
    end where
  end subroutine unsetOnMask

  subroutine unsetOnMask1(aFlags, aMask, index, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.unsetOnMask1 (Subroutine)
    !DES: flags2d8b.unsetOnMask restricted to slice in dimension 1
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1, dimension(n_aFlags1)             :: aMask
    integer*4                                   :: index
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*1 intent(in)                  :: aMask
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    where( aMask /= 0 )
       aFlags(:,index) = iand(aFlags(:,index), not(bitmask))
    end where
  end subroutine unsetOnMask1
 
  subroutine unsetOnMask2(aFlags, aMask, index, bitmask, n_aFlags1, n_aFlags2)
    !"""
    !NAM: flags2d8b.setOnMask2 (Subroutine)
    !DES: flags2d8b.setOnMask restricted to slice in dimension 2
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1, dimension(n_aFlags2)             :: aMask
    integer*4                                   :: index
    integer*1                                   :: bitmask
    !f2py integer*1 intent(inplace)             :: aFlags
    !f2py integer*1 intent(in)                  :: aMask
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)

    where( aMask /= 0 )
       aFlags(index,:) = iand(aFlags(index,:), not(bitmask))
    end where
  end subroutine unsetOnMask2

  subroutine isSetMask(aFlags, bitmask, n_aFlags1, n_aFlags2, aMask)
    !"""
    !NAM: flags2d8b.isSetMask (Subroutine)
    !DES: Returns a mask that indicates for which elements
    !     of aFlags at least one of the flag values specified by
    !     bitmask is set.
    !INP: aFlags (integer*1(n_aFlags1, n_aFlags2)) : Flag array
    !     bitmask (integer*1)          : Specifies the flag values
    !OUT: aMask (integer*1(n_aFlags1, n_aFlags2)) : Mask indicating that at least one of
    !                                    the flag values
    !                                    specified by bitmask is set for the corresponding
    !                                    element of aFlags.
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1                                   :: bitmask
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aMask
    !f2py integer*1 intent(in)                  :: aFlags
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py intent(out)                           :: aMask

    aMask = (iand(aFlags, bitmask) /= 0)
    ! Necessary since conversion from logical to integer*1 may yield -1
    aMask = abs(aMask)
  end subroutine isSetMask

  subroutine isSetMask1(aFlags, index, bitmask, n_aFlags1, n_aFlags2, aMask)
    !"""
    !NAM: flags2d8b.isSetMask1 (Subroutine)
    !DES: flags2d8b.isSetMask restricted to slice in dimension 1
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1                                   :: bitmask
    integer*4                                   :: index
    integer*1, dimension(n_aFlags1)             :: aMask
    !f2py integer*1 intent(in)                  :: aFlags
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py intent(out)                           :: aMask

    aMask = (iand(aFlags(:,index), bitmask) /= 0)
    ! Necessary since conversion from logical to integer*1 may yield -1
    aMask = abs(aMask)
  end subroutine isSetMask1

  subroutine isSetMask2(aFlags, index, bitmask, n_aFlags1, n_aFlags2, aMask)
    !"""
    !NAM: flags2d8b.isSetMask2 (Subroutine)
    !DES: flags2d8b.isSetMask restricted to slice in dimension 2
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1                                   :: bitmask
    integer*4                                   :: index
    integer*1, dimension(n_aFlags2)             :: aMask
    !f2py integer*1 intent(in)                  :: aFlags
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py intent(out)                           :: aMask

    aMask = (iand(aFlags(index,:), bitmask) /= 0)
    ! Necessary since conversion from logical to integer*1 may yield -1
    aMask = abs(aMask)
  end subroutine isSetMask2

  subroutine isUnsetMask(aFlags, bitmask, n_aFlags1, n_aFlags2, aMask)
    !"""
    !NAM: flags2d8b.isSetMask (Subroutine)
    !DES: Returns a mask that indicates for which elements
    !     of aFlags at least one of the flag values specified by
    !     bitmask is set.
    !INP: aFlags (integer*1(n_aFlags1, n_aFlags2)) : Flag array
    !     bitmask (integer*1)          : Specifies the flag values
    !OUT: aMask (integer*1(n_aFlags1, n_aFlags2)) : Mask indicating that at least one of
    !                                    the flag values
    !                                    specified by bitmask is set for the corresponding
    !                                    element of aFlags.
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1                                   :: bitmask
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aMask
    !f2py integer*1 intent(in)                  :: aFlags
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py intent(out)                           :: aMask

    aMask = (iand(aFlags, bitmask) == 0)
    ! Necessary since conversion from logical to integer*1 may yield -1
    aMask = abs(aMask)
  end subroutine isUnsetMask

  subroutine isUnsetMask1(aFlags, index, bitmask, n_aFlags1, n_aFlags2, aMask)
    !"""
    !NAM: flags2d8b.isUnsetMask1 (Subroutine)
    !DES: flags2d8b.isUnsetMask restricted to slice in dimension 1
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1                                   :: bitmask
    integer*4                                   :: index
    integer*1, dimension(n_aFlags1)             :: aMask
    !f2py integer*1 intent(in)                  :: aFlags
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py intent(out)                           :: aMask

    aMask = (iand(aFlags(:,index), bitmask) == 0)
    ! Necessary since conversion from logical to integer*1 may yield -1
    aMask = abs(aMask)
  end subroutine isUnsetMask1

  subroutine isUnsetMask2(aFlags, index, bitmask, n_aFlags1, n_aFlags2, aMask)
    !"""
    !NAM: flags2d8b.isUnsetMask2 (Subroutine)
    !DES: flags2d8b.isUnsetMask restricted to slice in dimension 2
    !INP: index (integer*4) : Specifies slice
    !"""
    integer*4                                   :: n_aFlags1, n_aFlags2
    integer*1, dimension(n_aFlags1, n_aFlags2)  :: aFlags
    integer*1                                   :: bitmask
    integer*4                                   :: index
    integer*1, dimension(n_aFlags2)             :: aMask
    !f2py integer*1 intent(in)                  :: aFlags
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags1 = shape(aFlags,0)
    !f2py integer*4 intent(hide),depend(aFlags) :: n_aFlags2 = shape(aFlags,1)
    !f2py integer*4 intent(in)                  :: index
    !f2py integer*1 intent(in)                  :: bitmask
    !f2py intent(out)                           :: aMask

    aMask = (iand(aFlags(index,:), bitmask) == 0)
    ! Necessary since conversion from logical to integer*1 may yield -1
    aMask = abs(aMask)
  end subroutine isUnsetMask2

end module flags2d8b

SUBROUTINE wavetransform1d(np,data,ns,wtrans)
! """
! NAM: waveTransform1D (subroutine)
! DES: Computes the wavelet transform of an image using the 'a trou' algorithm and a B3-spline wavelet
! INP: data   : input rank-1 array('f') to be decomposed
!      ns     : number of wavelet scales
! OUT: wtrans : rank-2 array('f') with shape (len(data),ns). 
! """ 
!-----------------------------------
!INOUT
  integer*8                                    :: np
  real*4, dimension(np)                        :: data
  integer*4                                    :: ns
  real*4, dimension(np,ns)                     :: wtrans
  integer*4,parameter                          :: filtsize=5
  real*4, dimension(filtsize)                  :: filter = (/ 1./16. , 1./4.,  3./8.,  1./4., 1./16. /)
  !f2py integer*8, intent(hide),depend(data)   :: np=len(data)
  !f2py real*4, intent(in)                     :: data
  !f2py integer*4, intent(in)                  :: ns
  !f2py real*4, intent(out)                    :: wtrans
!-----------------------------------
!LOCAL
  integer*8, dimension(filtsize)               :: x_filt
  integer*4                                    :: s
  integer*8                                    :: i, j, x
  real*4, dimension(np)                        :: smoothed
  real*4, dimension(np)                        :: c
!-----------------------------------
 
  ! Initialize pixel filter
  DO i=1,filtsize
    x_filt(i) = i - FLOOR( filtsize/2. ) -1
  END DO
  
  s = FLOOR( LOG(real(np)) / LOG(2.) )
  IF (ns > s) THEN
   	WRITE(*,*) "Warning: Maximum number of scales for input is ",s
   	WRITE(*,*) "Warning: Returning empty array ..."	
   	RETURN
  END IF
  
  DO i = 1,np
  	c(i) = data(i)
  END DO
  DO s = 0,(ns-2)
	DO i = 1,np
		smoothed(i) = 0.
		DO j = 1,filtsize
		   x = x_filt(j) + i
		   IF (x < 1) THEN
		     x = 2 - x
		   END IF
		   IF (x > np) THEN
		     x = 2*np -x
		   END IF
		  smoothed(i) =  smoothed(i) + filter(j)*c(x)
		END DO
	        wtrans(i,s+1) = c(i) - smoothed(i)
	END DO
	DO i = 1,np
	  	c(i) = smoothed(i)
	ENd DO
	DO i = 1,filtsize
		x_filt(i)=x_filt(i)*2
	END DO
  END DO

  wtrans(:,ns) = smoothed

END SUBROUTINE wavetransform1d

SUBROUTINE wavetransform2d(nx,ny,data,ns,wtrans)
! """
! NAM: waveTransform2D (subroutine)
! DES: Computes the wavelet transform of an image using the 'a trou' algorithm and a B3-spline wavelet
! INP: data   : input rank-2array('f') to be decomposed
!      ns     : number of wavelet scales
! OUT: wtrans : rank-3 array('f') with shape (len(data),ns). 
! """ 
!-----------------------------------
!INOUT
  integer*8                                    :: nx
  integer*8                                    :: ny
  real*4, dimension(nx,ny)                     :: data
  integer*4                                    :: ns
  real*4, dimension(nx,ny,ns)                  :: wtrans
  integer*4,parameter                          :: filtsize=5
  real*4, dimension(filtsize)                  :: filter = (/ 1./16. , 1./4.,  3./8.,  1./4., 1./16. /)
  real*4, dimension(filtsize,filtsize)         :: filter2d
  !f2py integer*8, intent(hide),depend(data)   :: nx=shape(data,0),ny=shape(data,1)
  !f2py real*4, intent(in)                     :: data
  !f2py integer*4, intent(in)                  :: ns
  !f2py real*4, intent(out)                    :: wtrans
!-----------------------------------
!LOCAL
  integer*8, dimension(filtsize)      	       :: pix_filt
  integer*4                                    :: s
  integer*8                                    :: i, j, k, l, y, x
  real*4, dimension(nx,ny)                     :: smoothed
  real*4, dimension(nx,ny)                     :: c
!-----------------------------------
 
  ! Initialize pixel filters
  DO i=1,filtsize
  	pix_filt(i) = i - FLOOR( filtsize/2. ) -1
  	DO j=1,filtsize
    		filter2d(i,j) = filter(i)*filter(j)
  	END DO
  END DO
  
  s = FLOOR( LOG(real(min(nx,ny))) / LOG(2.) )
  IF (ns > s) THEN
   	WRITE(*,*) "Warning: Maximum number of scales for input is ",s
   	WRITE(*,*) "Warning: Returning empty array ..."	
   	RETURN
  END IF
  
  DO i = 1,nx
  	DO j = 1,ny
  		c(i,j) = data(i,j)
  	END DO
  END DO

  DO s = 0,(ns-2)

	DO i = 1,nx
		DO j = 1,ny
			smoothed(i,j) = 0.
			DO k = 1,filtsize
				DO l = 1,filtsize
		       			x = pix_filt(k) + i
		       			y = pix_filt(l) + j
		       			IF (x < 1) THEN
		          			x = 2 - x
		      		 	END IF
		       			IF (x > nx) THEN
		          			x = 2*nx -x
		      			END IF
		       			IF (y < 1) THEN
		          			y = 2 - y
		      		 	END IF
		       			IF (y > ny) THEN
		          			y = 2*ny -y
		      			END IF
		       			smoothed(i,j) =  smoothed(i,j) + filter2d(k,l)*c(x,y)
		 		END DO
		 	END DO
	          	wtrans(i,j,s+1) = c(i,j) - smoothed(i,j)
	     	END DO
	END DO

	DO i = 1,nx
		DO j = 1,ny
	  		c(i,j) = smoothed(i,j)
		END DO
	END DO

	DO i = 1,filtsize
		pix_filt(i) = pix_filt(i)*2
	END DO

  END DO

  wtrans(:,:,ns) = smoothed

END SUBROUTINE wavetransform2d

! Copyright (C) 2002-2006
! Max-Planck-Institut fuer Radioastronomie Bonn
! Argelander Institut fuer Astronomie
! Astronomisches Institut der Ruhr-Universität Bochum
!
! Produced for the LABOCA project
!
! This library is free software; you can redistribute it and/or modify it under
! the terms of the GNU Library General Public License as published by the Free
! Software Foundation; either version 2 of the License, or (at your option) any
! later version.
!
! This library is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY FITNESS
! FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
! details.
!
! You should have received a copy of the GNU Library General Public License
! along with this library; if not, write to the Free Software Foundation, Inc.,
! 675 Massachusetts Ave, Cambridge, MA 02139, USA.  
!

subroutine flagInTime(ChanList,DataFlag,Time,above,below,flagIn,flagOut,nFlags,nChanList,nChan,nInt)
! """
! DES: flag the data w. time
! INP:
!      ChanList = flag only this channels indexes
!      Dataflag = entire flag array
!          time = time stream  
!   below,above = the limits
!        flagIn = the flag which should be tested
!       flagOut = the value of the flag to put
!     nChanList = the lenght of ChanList
!         nChan = nb. channels
!          nInt = number of time steps
! OUT: DataFlag = updated DataFlag array
!         nFlag = number of timestamp flagged
! """
!INOUT ----------------------------
  integer                             :: nFlags, nInt, nChan, nChanList
  integer, dimension(nChanList)       :: ChanList
  integer, dimension(nInt,nChan)      :: DataFlag
  real, dimension(nInt)               :: Time
  real                                :: above, below
  integer                             :: flagIn,flagOut
  !f2py intent(hide),depend(DataFlag) :: nInt=shape(DataFlag,0),nChan=shape(DataFlag,1)
  !f2py intent(hide),depend(chanList) :: nChanList=shape(ChanList)
  !f2py intent(in)                    :: ChanList, Time, below, above, flag
  !f2py intent(in,out)                :: DataFlag
  !f2py intent(hide,out)              :: nFlags
  !LOCAL ----------------------------
  integer                             :: iChannel, index, nToFlag
  logical, dimension(nInt)            :: time_mask, flag_mask
  ! ---------------------------------
  

  time_mask = (Time.ge.above).and.(Time.le.below)

  nFlags = 0
  DO iChannel=1,nChanList
     ! index in the data/flag array (remember fortran indexing)
     index = ChanList(iChannel)+1
     
     ! find the value we want to flag i.e. the flagIn within time_mask
     flag_mask = (DataFlag(:,index).eq.flagIn).and.time_mask
     nToFlag = COUNT(flag_mask)
     
     IF (nToFlag>0) THEN
        nFlags = nFlags+nToFlag
        where(flag_mask) DataFlag(:,index) = flagOut
     END IF
     
  END DO
  
END SUBROUTINE flagInTime

subroutine flagPosition(ChanList,DataFlag, AzEl, Offsets, AzElRef, radius, flag, nChanList, nChan, nInt, nFlags)
! """
! DES: flag the data around a position in sky
! INP:
!      ChanList = flag only this channels indexes
!      Dataflag = entire flag array
!         AzEl  = Reference Position of the array with...
!       Offsets = ... channel Offsets for the Used Channel only
!       AzElRef = Position  to flag...
!       radius  = .. within the given radius
!          flag = the value of the flag to put
!     nChanList = the lenght of ChanList
!         nChan = nb. channels
!          nInt = number of time steps
! OUT: DataFlag = updated DataFlag array
!         nFlag = number of timestamp flagged
! """
!INOUT ----------------------------
  integer                             :: nFlags, nInt, nChan, nChanList
  integer, dimension(nChanList)       :: ChanList
  integer, dimension(nInt,nChan)      :: DataFlag
  real,    dimension(2,nInt)          :: AzEl
  real,    dimension(2,nChan)         :: Offsets
  real,    dimension(2)               :: AzElRef
  real                                :: radius
  integer                             :: flag
  !f2py intent(hide),depend(DataFlag) :: nInt=shape(DataFlag,0),nChan=shape(DataFlag,1)
  !f2py intent(hide),depend(chanList) :: nChanList=shape(ChanList)
  !f2py intent(in)                    :: ChanList, AzEl, Offsets, AzElRef, radius, flag
  !f2py intent(in,out)                :: DataFlag
  !f2py intent(hide,out)              :: nFlags
  !LOCAL ----------------------------
  integer                             :: iChannel, index, nToFlag
  logical, dimension(nInt)            :: flag_mask
  real, dimension(nInt)               :: dist
  real,    dimension(2,nInt)          :: iAzEl
  ! ---------------------------------
  
  nFlags = 0
  DO iChannel=1,nChanList
     ! index in the data/flag array (remember fortran indexing)
     index = ChanList(iChannel)+1

     iAzEl(1,:) = AzEl(1,:)+Offsets(1,index)-AzElRef(1)
     iAzEl(2,:) = AzEl(2,:)+Offsets(2,index)-AzElRef(2)
     
     ! find out the valid channels defined in the aperture
     flag_mask = (SQRT(SUM(iAzEl**2,DIM=1)).le.radius).and.(DataFlag(:,index).eq.0)
     nToFlag = COUNT(flag_mask)

     IF (nToFlag>1) THEN
        nFlags = nFlags+nToFlag
        where(flag_mask) DataFlag(:,index) = flag
     END IF
     
  END DO
  
END SUBROUTINE flagPosition

!module fMap

!contains

subroutine ksmooth(image,nx,ny,kernel,nk)
! """
! NAM: ksmooth (subroutine)
! DES: Smooth an image with a given kernel 
!      the kernel should have a squared support with odd dimension
! INP: image : input rank-2 array('f') with bounds (nx,ny); nx>1,ny>1
!      kernel  input rank-2 array('f') with bounds (nk,nk); nk have to be odd and >1
! OUT: image : rank-2 array('f') with bounds (nx,ny). 
! """ 
!-----------------------------------
!INOUT
 integer                              :: nx,ny, nk
 real, dimension(nx,ny)   :: image
 real, dimension(nk,nk)   :: kernel
 !f2py intent(hide),depend(image)     :: nx=shape(image,0),ny=shape(image,1)
 !f2py intent(hide),depend(kernel)    :: nk=shape(kernel,0)
 !f2py intent(in,out)                 :: image
 !f2py intent(in)                     :: kernel
!-----------------------------------
!LOCAL
 real, allocatable,dimension(:,:) :: WorkImage,subimage
 logical, allocatable,dimension(:,:)          :: mask
 integer                                      :: i,j,ng
!-----------------------------------

!---- from gsmooth

 ng = (nk-1)/2           ! range of kernel in whole pixel

 ! create an image with size of original image + 2 * the size of the kernel....

 ALLOCATE(WorkImage(nx+2*ng,ny+2*ng))

 ! ... fill it first with NaN (SQRT(-1) should provide NaN) ...
 WorkImage = -1
 WorkImage = SQRT(WorkImage)
 !  ... and put the original image in the middle
 WorkImage(ng+1:nx+ng,ng+1:ny+ng) = image


! all work is done on a subimage of the size of the kernel
 ALLOCATE(subimage(nk,nk),mask(nk,nk))


 DO i=ng+1,ng+nx       ! loop through all pixels in image
    DO j=ng+1,ng+ny
       ! Extract the corresponding subimage
       subimage = WorkImage(i-ng:i+ng,j-ng:j+ng)
       
       ! test for the presence of NaN (IEEE x.eq.y should fail for NaN even if x=y=NaN)
       ! for ifc one need to use the -mp1 option for that to work
       mask = (subimage.eq.subimage).and.(kernel.eq.kernel)
       
       ! If there is something in the subimage and the kernel AND the
       ! original pixel is not a NaN then....
       IF (any(mask).and.(image(i-ng,j-ng).eq.image(i-ng,j-ng))) THEN
          image(i-ng,j-ng) = sum( kernel*subimage, MASK=mask)/SUM(kernel, MASK=mask)
       ENDIF
    ENDDO
 ENDDO
 
 DEALLOCATE(WorkImage,subimage,mask)

end subroutine ksmooth


SUBROUTINE wcs2pix(X,Y,AXIS1,AXIS2,I,J, nInt)
! """
! DES: compute the pixel coordinates from real world coordinates
! INP:
!        X/Y  = real world coordinates
!     AXIS1/2 = the description of the 2 WCS AXIS [ NAXIS?, CRPIX?, CDELT?, CRVAL?, UNIT]
! OUT:   i/j  = the corresponding pixels indexes
!
! WAR: This does NOT return pixel coordinates but pixel 0 indexes
!      See WCS definition for more details
! 
!     should be changed to use libwcs at some point
! """
!INOUT ----------------------------
  integer                      :: nInt
  real, dimension(nInt)        :: X,Y
  real, dimension(nInt)        :: I,J
  real, dimension(5)           :: AXIS1,AXIS2
  !f2py intent(hide),depend(X) :: nInt=shape(X)
  !f2py intent(in)             :: X,Y,AXIS1,AXIS2
  !f2py intent(out)            :: I,J
  real                         :: Deg2Rad

  ! CRVAL? = AXIS?(4)
  ! CDELT? = AXIS?(3) + unit in AXIS?(5)
  ! CRPIX? = AXIS?(2)

  Deg2Rad = 4.d0*datan(1.d0)/180

  I = (X-AXIS1(4))/AXIS1(3)*cos(Y*AXIS2(5) * Deg2Rad )+AXIS1(2)
  J = (Y-AXIS2(4))/AXIS2(3)+AXIS2(2)

  ! the pixel coordinates are the center of the pixel, since we need the pixel index we need to subtract 0.5
  I = I-0.5
  J = J-0.5

  ! results are 0 indexed remember to add +1 if used in fortran

END SUBROUTINE wcs2pix

SUBROUTINE wcs2phy(I,J,AXIS1,AXIS2,X,Y, nInt)
! """
! DES: compute the pixel coordinates from real world coordinates
! INP:
!        i/j  = pixel indexes
!     AXIS1/2 = the description of the 2 WCS AXIS [ NAXIS?, CRPIX?, CDELT?, CRVAL?, UNIT]
! OUT:   X/Y  = corresponding real world coordinates
!
! WAR: This takes pixel 0 indexes and NOT pixel coordinates
!      See WCS definition for more details
! """
!INOUT ----------------------------
  integer                      :: nInt
  real, dimension(nInt)        :: X,Y
  real, dimension(nInt)        :: I,J
  real, dimension(5)           :: AXIS1,AXIS2
  !f2py intent(hide),depend(X) :: nInt=shape(X)
  !f2py intent(in)             :: I,J,AXIS1,AXIS2
  !f2py intent(out)            :: X,Y
  real                         :: Deg2Rad

  Deg2Rad = 4.d0*datan(1.d0)/180

  ! transform pixel 0-indexes to pixel coordinates : 
  I = I+0.5
  J = J+0.5

  ! and make the transformation
  Y = AXIS2(4) + (J-AXIS2(2))*AXIS2(3)
  X = AXIS1(4) + (I-AXIS1(2))*AXIS1(3)/cos(Y*AXIS2(5) * Deg2Rad)

END SUBROUTINE wcs2phy


SUBROUTINE HorizontalProjection(ChanList, Data, DataWeights, DataFlags, flag, &
     &AzEl, Offsets, rotAngles, AXIS1, AXIS2, map, weight, coverage, &
     &nChanList, nChan,nInt, dimX, dimY)

! """
! DES: Project the signal in Horizontal Coordinates according to a list of Channel
! INP:
!              ChanList = map only this channels indexes
!                  Data = entire data array ...
!           DataWeights = ... with corresponding weights ..
!              DataFlag = ... and flags
!                 flag  = flag to select the data
!                 AzEl  = Reference Position of the array with...
!               Offsets = ... channel Offsets only for the entire array ...
!             rotAngles = ... and the rotation of the offsets
!             nChanList = the lenght of ChanList
!                 nChan = nb. channels
!                  nInt = number of time steps
!            dimX dimY  = the dimension of the maps
!   map/weight/coverage = a initial version of the maps.
!               AXIS1/2 = the WCS description of the map axis
! OUT:
!   map/weight/coverage = the resulting signal, weight and coverage (weight=1) map
!         
! """
!INOUT -----------------------------
  integer                         :: nChanList, nChan, nInt, dimX, dimY
  integer, dimension(nChanList)   :: ChanList
  real,    dimension(nInt,nChan)  :: Data, DataWeights
  integer, dimension(nInt,nChan)  :: DataFlags
  integer                         :: flag
  real,    dimension(2,nInt)      :: AzEl
  real,    dimension(2,nChan)     :: Offsets
  real,    dimension(nInt)        :: rotAngles
  real,    dimension(5)           :: AXIS1,AXIS2
  real,    dimension(dimX,dimY)   :: map, weight, coverage
  !f2py intent(hide),depend(ChanList) :: nChanlist = shape(ChanList)
  !f2py intent(hide),depend(Data) :: nInt = shape(Data,0), nChan = shape(Data,1)
  !f2py inten(hide),depend(map)   :: dimX = shape(map,0), dimY = shape(map,1)
  !f2py intent(in)                :: ChanList, Data, DataFlags, DataWeights, AzEl, Offsets, rotAngles, AXIS, AXIS2
  !f2py intent(in,out)            :: map, weight, coverage
!-----------------------------------
!LOCAL
  integer                             :: iChannel, index, nGood
  logical, dimension(nInt)            :: flag_mask
  real,    allocatable,dimension(:)   :: iAz, iEl, iData, iWeights
!  integer, allocatable,dimension(:)   :: I, J
  real, allocatable,dimension(:)      :: I, J
  real                                :: fracI,fracJ
  real                                :: Deg2Rad
  real,  dimension(nInt)              :: cosAngle, sinAngle
  integer                             :: intI,intJ
!-----------------------------------
  Deg2Rad = 4.d0*datan(1.d0)/180

  cosAngle = cos(rotAngles*Deg2Rad)
  sinAngle = sin(rotAngles*Deg2Rad)
  
  DO iChannel=1,nChanList
     ! index in the data/flag array (remember fortran indexing)
     index = ChanList(iChannel)+1

     ! find the value we want to flag i.e. the flagIn within time_mask
     flag_mask = DataFlags(:,index).eq.flag
     nGood = COUNT(flag_mask)

     IF (nGood>1) THEN
        ALLOCATE(iAz(nGood))
        ALLOCATE(iEl(nGood))
        ALLOCATE(iData(nGood))
        ALLOCATE(iWeights(nGood))
        ALLOCATE(I(nGood))
        ALLOCATE(J(nGood))

        iAz      = PACK(AzEl(1,:),            mask=flag_mask)+Offsets(1,index) *  cosAngle + Offsets(2,index) * - sinAngle
        iEl      = PACK(AzEl(2,:),            mask=flag_mask)+Offsets(1,index) * sinAngle + Offsets(2,index) * cosAngle
        iData    = PACK(Data(:,index),        mask=flag_mask)
        iWeights = PACK(DataWeights(:,index), mask=flag_mask)
        
        ! Compute the corresponding pixel index
        CALL wcs2pix(iAz, iEl, AXIS1, AXIS2, I, J, nGood)

        ! wcspix if 0 indexed so... 
        I = I+1
        J = J+1
 
        DO iGood = 1, nGood
           intI = floor(I(iGood))
           intJ = floor(J(iGood))
           IF ((1.le.intI).and.(intI.le.dimX).and.(1.le.intJ).and.(intJ.le.dimY)) THEN
              map(intI,intJ)      = map(intI,intJ)      + iData(iGood)*iWeights(iGood)
              weight(intI,intJ)   = weight(intI,intJ)   + iWeights(iGood)
              coverage(intI,intJ) = coverage(intI,intJ) + 1
!            ! spread signal among the four neighbouring pixels
!            IF ((1.le.I(iGood)).and.(I(iGood).le.dimX-1).and.(1.le.J(iGood)).and.(J(iGood).le.dimY-1)) THEN
!               intI = floor(I(iGood))
!               intJ = floor(J(iGood))
!               fracI = I(iGood) - intI
!               fracJ = J(iGood) - intJ
!               map(intI,intJ)          = map(intI,intJ)          + iData(iGood)*iWeights(iGood)*(1.-fracI)*(1.-fracJ)
!               weight(intI,intJ)       = weight(intI,intJ)       + iWeights(iGood)*(1.-fracI)*(1.-fracJ)
!               coverage(intI,intJ)     = coverage(intI,intJ)     + (1.-fracI)*(1.-fracJ)
!               map(intI+1,intJ)        = map(intI+1,intJ)        + iData(iGood)*iWeights(iGood)*fracI*(1.-fracJ)
!               weight(intI+1,intJ)     = weight(intI+1,intJ)     + iWeights(iGood)*fracI*(1.-fracJ)
!               coverage(intI+1,intJ)   = coverage(intI+1,intJ)   + fracI*(1.-fracJ)
!               map(intI,intJ+1)        = map(intI,intJ+1)        + iData(iGood)*iWeights(iGood)*(1.-fracI)*fracJ
!               weight(intI,intJ+1)     = weight(intI,intJ+1)     + iWeights(iGood)*(1.-fracI)*fracJ
!               coverage(intI,intJ+1)   = coverage(intI,intJ+1)   + (1.-fracI)*fracJ
!               map(intI+1,intJ+1)      = map(intI+1,intJ+1)      + iData(iGood)*iWeights(iGood)*fracI*fracJ
!               weight(intI+1,intJ+1)   = weight(intI+1,intJ+1)   + iWeights(iGood)*fracI*fracJ
!               coverage(intI+1,intJ+1) = coverage(intI+1,intJ+1) + fracI*fracJ
           ENDIF


        ENDDO
        
        DEALLOCATE(iAz)
        DEALLOCATE(iEl)
        DEALLOCATE(iData)
        DEALLOCATE(iWeights)
        DEALLOCATE(I)
        DEALLOCATE(J)

     END IF
     
  END DO

! Allow division by 0, i.e having NaN where weight = 0  
  map = map/weight

END SUBROUTINE HorizontalProjection


SUBROUTINE EquatorialProjection(ChanList, Data, DataWeights, DataFlags, flag, &
     &RaDec, OffsetsAzEl, rotAngles, refChOffsets, &
     &AXIS1, AXIS2, neighbour, map, weight, coverage, &
     &nChanList, nChan,nInt, dimX, dimY)

! """
! DES: Project the signal in Equatorial Coordinates according to a list of Channel
! INP:
!              ChanList = flag only this channels indexes
!                  Data = entire data array ...
!           DataWeights = ... with corresponding weights ..
!              DataFlag = ... and flags
!                 flag  = flag to select the data
!                 RaDec = Reference Position of the array (EQUATORIAL!) with...
!           OffsetsAzEl = ... channel Offsets (HORIZONTAL!) for the Used Channels only
!             rotAngles = rotation angle at each time stamp
!             nChanList = the lenght of ChanList
!                 nChan = nb. channels
!                  nInt = number of time steps
!            dimX dimY  = the dimension of the maps
!   map/weight/coverage = a initial version of the maps.
!               AXIS1/2 = the WCS description of the map axis
!             neighbour = do we divide the flux to 4 neighbouring pixels?
! OUT:
!   map/weight/coverage = the resulting signal, weight and coverage (weight=1) map
!         
! """
!INOUT -----------------------------
  integer                         :: nChanList, nChan, nInt, dimX, dimY
  integer, dimension(nChanList)   :: ChanList
  real,    dimension(nInt,nChan)  :: Data, DataWeights
  integer, dimension(nInt,nChan)  :: DataFlags
  integer                         :: flag
  real,    dimension(2,nInt)      :: RaDec
  real,    dimension(2,1)         :: refChOffsets
  real,    dimension(nInt)        :: rotAngles 
  real,    dimension(2,nChan)     :: OffsetsAzEl
  real,    dimension(5)           :: AXIS1,AXIS2
  real,    dimension(dimX,dimY)   :: map, weight, coverage
  !f2py intent(hide),depend(ChanList) :: nChanlist = shape(ChanList)
  !f2py intent(hide),depend(Data) :: nInt = shape(Data,0), nChan = shape(Data,1)
  !f2py inten(hide),depend(map)   :: dimX = shape(map,0), dimY = shape(map,1)
  !f2py intent(in)                :: ChanList, Data, DataFlags, DataWeights, RaDec, OffsetsAzEl, AXIS, AXIS2, rotAngles, refChOffsets
  !f2py intent(in,out)            :: map, weight, coverage
!-----------------------------------
!LOCAL
  integer                             :: iChannel, index, nGood
  real,    dimension(2,nInt)          :: ChRaDec
  real,    dimension(2,1)             :: OffsetsRaDec, OffsetsUsedRaDec
  logical, dimension(nInt)            :: flag_mask
  real,    allocatable,dimension(:)   :: iRa, iDec, iData, iWeights
!  integer, allocatable,dimension(:)   :: I, J
  real, allocatable,dimension(:)      :: I, J
  real                                :: fracI,fracJ
  real                                :: Deg2Rad
  integer                             :: intI,intJ
!-----------------------------------

  Deg2Rad = 4.d0*datan(1.d0)/180

  DO iChannel=1,nChanList

     ! index in the data/flag array (remember fortran indexing)
     index = ChanList(iChannel)+1
     
     ! find the value we want to flag i.e. the flagIn within time_mask
     flag_mask = DataFlags(:,index).eq.flag
     nGood = COUNT(flag_mask)

     IF (nGood>1) THEN

        ALLOCATE(iRa(nGood))
        ALLOCATE(iDec(nGood))
        ALLOCATE(iData(nGood))
        ALLOCATE(iWeights(nGood))
        ALLOCATE(I(nGood))
        ALLOCATE(J(nGood))

        OffsetsAzEl(1,index) = OffsetsAzEl(1,index) - refChOffsets(1,1)
        OffsetsAzEl(2,index) = OffsetsAzEl(2,index) - refChOffsets(2,1)
        DO iInteg=1, nInt 
           call RotateOffset(OffsetsAzEl(:,index),OffsetsRaDec,rotAngles(iInteg))
           !OffsetsRaDec(:,1)=OffsetsRaDec(:,1)-refChOffsets(:,1)
           !OffsetsRaDec(1,1)=-1.*OffsetsRaDec(1,1)
           chRaDec(2,iInteg) = RaDec(2,iInteg)+OffsetsRaDec(2,1)/3600.
           OffsetsRaDec(1,1) = OffsetsRaDec(1,1)/cos(chRaDec(2,iInteg)*Deg2Rad)
           chRaDec(1,iInteg) = RaDec(1,iInteg)+OffsetsRaDec(1,1)/3600. 
        ENDDO
        
        iRa      = PACK(chRaDec(1,:),         mask=flag_mask)
        iDec     = PACK(chRaDec(2,:),         mask=flag_mask)
        iData    = PACK(Data(:,index),        mask=flag_mask)
        iWeights = PACK(DataWeights(:,index), mask=flag_mask)
        
        ! Compute the corresponding pixel index
        CALL wcs2pix(iRa, iDec, AXIS1, AXIS2, I, J, nGood)

        ! wcspix if 0 indexed so...
        I = I+1
        J = J+1

        DO iGood = 1, nGood
           IF (neighbour == 0) THEN
              intI = floor(I(iGood))
              intJ = floor(J(iGood))
              IF ((1.le.intI).and.(intI.le.dimX).and.(1.le.intJ).and.(intJ.le.dimY)) THEN
                 map(intI,intJ)      = map(intI,intJ)      + iData(iGood)*iWeights(iGood)
                 weight(intI,intJ)   = weight(intI,intJ)   + iWeights(iGood)
                 coverage(intI,intJ) = coverage(intI,intJ) + 1
              ENDIF
           ELSE
              intI = floor(I(iGood))
              intJ = floor(J(iGood))
              IF ((1.le.I(iGood)).and.(I(iGood).le.dimX-1).and.(1.le.J(iGood)).and.(J(iGood).le.dimY-1)) THEN
                 ! spread signal among the four neighbouring pixels
                 fracI = I(iGood) - intI
                 fracJ = J(iGood) - intJ
                 map(intI,intJ)          = map(intI,intJ)          + iData(iGood)*iWeights(iGood)*(1.-fracI)*(1.-fracJ)
                 weight(intI,intJ)       = weight(intI,intJ)       + iWeights(iGood)*(1.-fracI)*(1.-fracJ)
                 coverage(intI,intJ)     = coverage(intI,intJ)     + 1
                 map(intI+1,intJ)        = map(intI+1,intJ)        + iData(iGood)*iWeights(iGood)*fracI*(1.-fracJ)
                 weight(intI+1,intJ)     = weight(intI+1,intJ)     + iWeights(iGood)*fracI*(1.-fracJ)
                 coverage(intI+1,intJ)   = coverage(intI+1,intJ)   + 1
                 map(intI,intJ+1)        = map(intI,intJ+1)        + iData(iGood)*iWeights(iGood)*(1.-fracI)*fracJ
                 weight(intI,intJ+1)     = weight(intI,intJ+1)     + iWeights(iGood)*(1.-fracI)*fracJ
                 coverage(intI,intJ+1)   = coverage(intI,intJ+1)   + 1
                 map(intI+1,intJ+1)      = map(intI+1,intJ+1)      + iData(iGood)*iWeights(iGood)*fracI*fracJ
                 weight(intI+1,intJ+1)   = weight(intI+1,intJ+1)   + iWeights(iGood)*fracI*fracJ
                 coverage(intI+1,intJ+1) = coverage(intI+1,intJ+1) + 1
              ENDIF
           ENDIF
        ENDDO
        
        DEALLOCATE(iRa)
        DEALLOCATE(iDec)
        DEALLOCATE(iData)
        DEALLOCATE(iWeights)
        DEALLOCATE(I)
        DEALLOCATE(J)

     END IF
  END DO

! Allow division by 0, i.e having NaN where weight = 0
  map = map/weight

END SUBROUTINE EquatorialProjection


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! Routines related with source model (computing, flagging, adding)
!
SUBROUTINE ComputeModel(ChanList, Data, Model,  &
     &RaDec, OffsetsAzEl, rotAngles, refChOffsets, &
     &AXIS1, AXIS2, DataArray, &
     &nChanList, nChan,nInt, dimX, dimY)
! """
! DES: Computes a data array (same size as data: nchannels x ndumps)
!      according to a source model provided as a map
! INP:
!              ChanList = do computations only for these channels
!                  Data = entire data array
!                 Model = a 2D map containing the source model
!                 RaDec = Reference Position of the array (EQUATORIAL!) with...
!           OffsetsAzEl = ... channel Offsets (HORIZONTAL!) for the Used Channels only
!             rotAngles = rotation angle at each time stamp
!          refChOffsets = offsets (HORIZONTAL!) for the reference channel
!               AXIS1/2 = the WCS description of the map axis
! Derived:
!             nChanList = the length of ChanList
!                 nChan = total number of channels
!                  nInt = number of dumps
!            dimX, dimY = dimensions of model map
! OUT:
!             DataArray = the resulting array of data
!         
! """
!INOUT -----------------------------
  integer                         :: nChanList, nChan, nInt, dimX, dimY
  integer, dimension(nChanList)   :: ChanList
  real,    dimension(nInt,nChan)  :: Data, DataArray
  real,    dimension(2,nInt)      :: RaDec
  real,    dimension(2,1)         :: refChOffsets
  real,    dimension(nInt)        :: rotAngles 
  real,    dimension(2,nChan)     :: OffsetsAzEl
  real,    dimension(5)           :: AXIS1,AXIS2
  real,    dimension(dimX,dimY)   :: Model
  !f2py intent(hide),depend(ChanList) :: nChanlist = shape(ChanList)
  !f2py intent(hide),depend(Data) :: nInt = shape(Data,0), nChan = shape(Data,1)
  !f2py inten(hide),depend(Model) :: dimX = shape(Model,0), dimY = shape(Model,1)
  !f2py intent(in)                :: ChanList, Data, Model, RaDec, OffsetsAzEl
  !f2py intent(in)                :: AXIS1, AXIS2, rotAngles, refChOffsets
  !f2py intent(out)               :: DataArray
!-----------------------------------
!LOCAL
  integer                             :: iChannel, index, nGood
  real,    dimension(2,nInt)          :: ChRaDec
  real,    dimension(2,1)             :: OffsetsRaDec, OffsetsUsedRaDec
  real,    allocatable,dimension(:)   :: iRa, iDec
  real,    allocatable,dimension(:)   :: I, J
  integer                             :: intI,intJ
  real                                :: fracI,fracJ
!-----------------------------------

  ! We will loop through the time serie for each channel
  ALLOCATE(iRa(nInt))
  ALLOCATE(iDec(nInt))
  ALLOCATE(I(nInt))
  ALLOCATE(J(nInt))
  
  DO iChannel=1,nChanList
     ! index in the data array (remember fortran indexing)
     index = ChanList(iChannel)+1
     
     OffsetsAzEl(1,index) = OffsetsAzEl(1,index) - refChOffsets(1,1)
     OffsetsAzEl(2,index) = OffsetsAzEl(2,index) - refChOffsets(2,1)
     DO iInteg=1, nInt 
        call RotateOffset(OffsetsAzEl(:,index),OffsetsRaDec,rotAngles(iInteg))
        chRaDec(2,iInteg)=RaDec(2,iInteg)+OffsetsRaDec(2,1)/3600.
        OffsetsRaDec(1,1) = OffsetsRaDec(1,1)/cos(chRaDec(2,iInteg)*3.1415926535/180.)
        chRaDec(1,iInteg)=RaDec(1,iInteg)+OffsetsRaDec(1,1)/3600.
     ENDDO
        
     iRa      = chRaDec(1,:)
     iDec     = chRaDec(2,:)
        
     ! Compute the corresponding pixel coordinates
     CALL wcs2pix(iRa, iDec, AXIS1, AXIS2, I, J, nInt)

     ! wcs2pix is 0 indexed so...
     I = I+1
     J = J+1

     DO iGood = 1, nInt
        intI = floor(I(iGood)+0.5)
        intJ = floor(J(iGood)+0.5)
        IF ((1.le.intI).and.(intI.le.dimX).and.(1.le.intJ).and.(intJ.le.dimY)) THEN
           ! get signal at closest pixel
           fracI = I(iGood) - intI
           fracJ = J(iGood) - intJ
           IF (Model(intI,intJ).eq.Model(intI,intJ)) THEN
              ! this is true only if Model(intI,intJ) is not NaN
              DataArray(iGood,index) = Model(intI,intJ)
           ELSE
              DataArray(iGood,index) = 0.
           ENDIF
        ELSE
           DataArray(iGood,index) = 0.
        ENDIF
     ENDDO
  END DO

  DEALLOCATE(iRa)
  DEALLOCATE(iDec)
  DEALLOCATE(I)
  DEALLOCATE(J)
END SUBROUTINE ComputeModel

SUBROUTINE FlagSource(ChanList, Data, Model, threshold, flag, &
     &RaDec, OffsetsAzEl, rotAngles, refChOffsets, &
     &AXIS1, AXIS2, FlagArray, &
     &nChanList, nChan,nInt, dimX, dimY)

! """
! DES: Computes an array of flags (same size as data: nchannels x ndumps)
!      according to a source model provided as a map
! INP:
!              ChanList = do computations only for these channels
!                  Data = entire data array
!                 Model = a 2D map containing the source model
!             threshold = the value (in Model pixels) above which flag is set
!                  flag = the flag value to set
!                 RaDec = Reference Position of the array (EQUATORIAL!) with...
!           OffsetsAzEl = ... channel Offsets (HORIZONTAL!) for the Used Channels only
!             rotAngles = rotation angle at each time stamp
!          refChOffsets = offsets (HORIZONTAL!) for the reference channel
!               AXIS1/2 = the WCS description of the map axis
! Derived:
!             nChanList = the length of ChanList
!                 nChan = total number of channels
!                  nInt = number of dumps
!            dimX, dimY = dimensions of model map
! OUT:
!             FlagArray = the resulting array of flags
!         
! """
!INOUT -----------------------------
  integer                         :: nChanList, nChan, nInt, dimX, dimY
  real                            :: threshold
  integer, dimension(nChanList)   :: ChanList
  real,    dimension(nInt,nChan)  :: Data
  real,    dimension(nInt,nChan)  :: FlagArray
  integer                         :: flag
  real,    dimension(2,nInt)      :: RaDec
  real,    dimension(2,1)         :: refChOffsets
  real,    dimension(nInt)        :: rotAngles 
  real,    dimension(2,nChan)     :: OffsetsAzEl
  real,    dimension(5)           :: AXIS1,AXIS2
  real,    dimension(dimX,dimY)   :: Model
  !f2py intent(hide),depend(ChanList) :: nChanlist = shape(ChanList)
  !f2py intent(hide),depend(Data) :: nInt = shape(Data,0), nChan = shape(Data,1)
  !f2py inten(hide),depend(Model) :: dimX = shape(Model,0), dimY = shape(Model,1)
  !f2py intent(in)                :: ChanList, Data, Model, RaDec, OffsetsAzEl, AXIS1, AXIS2
  !f2py intent(in)                :: rotAngles, refChOffsets, threshold
  !f2py intent(in,out)            :: FlagArray
!-----------------------------------
!LOCAL
  logical, dimension(nint)        :: mask
  integer                         :: mask_count
  integer, dimension(:), allocatable :: aFlag
!-----------------------------------

  ! compute model
  call ComputeModel(ChanList, Data, Model, RaDec, OffsetsAzEl, rotAngles, refChOffsets, &
       &AXIS1, AXIS2, FlagArray, nChanList, nChan, nInt, dimX, dimY)

  ! loop on channels to fill the Flag array
  DO iChannel=1,nChanList
     ! index in the data array (remember fortran indexing)
     index = ChanList(iChannel)+1
     mask  = FlagArray(:,index).ge.threshold
     mask_count = COUNT(mask)
     IF (mask_count>0) THEN
        allocate(aFlag(mask_count))
        aFlag = flag
        FlagArray(:,index) = UNPACK(aFlag,MASK=mask,FIELD=0)
        deallocate(aFlag)
     ELSE
        FlagArray(:,index) = 0
     ENDIF
  ENDDO
END SUBROUTINE FlagSource

SUBROUTINE AddSource(ChanList, Data, Model, &
     &RaDec, OffsetsAzEl, rotAngles, refChOffsets, &
     &AXIS1, AXIS2, factor, &
     &nChanList, nChan,nInt, dimX, dimY)

! """
! DES: add factor x simulated data to the data, where simulated
!      data have the same size as data (nchannels x ndumps) and
!      are computed according to source model
! INP:
!              ChanList = do computations only for these channels
!                  Data = entire data array
!                 Model = a 2D map containing the source model
!                 RaDec = Reference Position of the array (EQUATORIAL!) with...
!           OffsetsAzEl = ... channel Offsets (HORIZONTAL!) for the Used Channels only
!             rotAngles = rotation angle at each time stamp
!          refChOffsets = offsets (HORIZONTAL!) for the reference channel
!               AXIS1/2 = the WCS description of the map axis
!                factor = applied to the sim'ed data (e.g. -1. to *subtract* source)
! Derived:
!             nChanList = the length of ChanList
!                 nChan = total number of channels
!                  nInt = number of dumps
!            dimX, dimY = dimensions of model map
! OUT:
!               the input Data array + factor x Sim. data is returned
!         
! """
!INOUT -----------------------------
  integer                         :: nChanList, nChan, nInt, dimX, dimY
  real                            :: factor
  integer, dimension(nChanList)   :: ChanList
  real,    dimension(nInt,nChan)  :: Data
  real,    dimension(2,nInt)      :: RaDec
  real,    dimension(2,1)         :: refChOffsets
  real,    dimension(nInt)        :: rotAngles 
  real,    dimension(2,nChan)     :: OffsetsAzEl
  real,    dimension(5)           :: AXIS1,AXIS2
  real,    dimension(dimX,dimY)   :: Model
  !f2py intent(hide),depend(ChanList) :: nChanlist = shape(ChanList)
  !f2py intent(hide),depend(Data) :: nInt = shape(Data,0), nChan = shape(Data,1)
  !f2py inten(hide),depend(Model) :: dimX = shape(Model,0), dimY = shape(Model,1)
  !f2py intent(in)                :: ChanList, Model, RaDec, OffsetsAzEl, AXIS1, AXIS2
  !f2py intent(in)                :: rotAngles, refChOffsets
  !f2py intent(in,out)            :: Data
!-----------------------------------
!LOCAL
  real,    dimension(nInt,nChan)  :: SimData
!-----------------------------------
  ! compute model
  call ComputeModel(ChanList, Data, Model, RaDec, OffsetsAzEl, rotAngles, refChOffsets, &
       &AXIS1, AXIS2, SimData, nChanList, nChan, nInt, dimX, dimY)
  Data = Data + factor * SimData

END SUBROUTINE AddSource


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

SUBROUTINE RotateOffset(azel_off,radec_off,angle)

  !INOUT ----------------------------
  real                         :: angle
  real, dimension(2,1)         :: azel_off, radec_off
  !f2py intent(in)             :: azel_off, angle
  !f2py intent(out)            :: radec_off  
  !LOCAl-----------------------------
  real                         :: ang
  real                         :: Deg2Rad
  real, dimension(2,2)         :: rotMatrix

  Deg2Rad = 4.d0*datan(1.d0)/180
  ang     = angle*Deg2Rad

  rotMatrix(1,1)=-1.*cos(ang)
  rotMatrix(1,2)=sin(ang)
  rotMatrix(2,1)=sin(ang)
  rotMatrix(2,2)=cos(ang)

  radec_off=matmul(rotMatrix,azel_off)

END SUBROUTINE RotateOffset

!----------------------------------------
subroutine mapsum(image1,weight1,coverage1,image2,weight2,coverage2,nx,ny,imageresult,coverageresult,weightresult)
!INOUT
integer                              :: nx,ny
real, dimension(nx,ny)   :: image1,image2,coverage1,coverage2,weight1,weight2
real, dimension(nx,ny)   :: imageresult,coverageresult,weightresult
!f2py intent(hide),depend(image1)     :: nx=shape(image,0),ny=shape(image,1)
!f2py intent(in)                      :: image1,image2,coverage1,coverage2,weight1,weight2
!f2py intent(out)                     :: imageresult,coverageresult,weightresult
!-----------------------------------------

imageresult = -1
imageresult = SQRT(imageresult)
coverageresult = 0
weightresult = 0

WHERE ((image1.eq.image1).and.(image2.eq.image2)) 
imageresult=image1*weight1+image2*weight2
weightresult = weight1+weight2
coverageresult = coverage1+coverage2
END WHERE

WHERE ((image1.eq.image1).and.(image2.ne.image2)) 
imageresult=image1*weight1
weightresult = weight1
coverageresult = coverage1
END WHERE

WHERE ((image1.ne.image1).and.(image2.eq.image2)) 
imageresult=image2*weight2
weightresult = weight2
coverageresult = coverage2
END WHERE

imageresult= imageresult/weightresult

END SUBROUTINE mapsum

! """
! DES: module collecting f90 subroutines for fitting purposes
! """ 
!=============================================================================
SUBROUTINE fit(x,y,a,b,n)
! """
! DES: Least Square fitting on x and y
! INP: 
!      x,y  : the input array
!      n    : the size of the input array
! OUT: a,b  : the result of the fit
!
! """
!INOUT
  integer                       :: n
  real,   dimension(n)          :: x,y
  real                          :: a,b
  !f2py intent(hide),depend(x)  :: n=shape(x)
  !f2py intent(in)              :: x,y
  !f2py intent(out)             :: a,b
!-----------------------------------
  real                          :: meanX,meanY,sumXX,sumXY
!-----------------------------------

! From Mathworld least square fitting
! http://mathworld.wolfram.com/LeastSquaresFitting.html

meanX = SUM(x(:))/n
meanY = SUM(y(:))/n

sumXX = DOT_PRODUCT(x,x)-n*meanX**2
sumXY = DOT_PRODUCT(x,y)-n*meanX*meanY

b = sumXY/sumXX
a = meanY-b*meanX

END SUBROUTINE fit

!=============================================================================
SUBROUTINE fit_slope(x,y,b,n)
! """
! DES: Least Square fitting on x and y, compute and return only the slope
! INP: 
!      x,y : the input array
!      n   : the size of the input array
! OUT: a   : the slope of the fit
!
! """
!INOUT
  integer                       :: n
  real,   dimension(n)          :: x,y
  real                          :: b
  !f2py intent(hide),depend(x)  :: n=shape(x)
  !f2py intent(in)              :: x,y
  !f2py intent(out)             :: b
!-----------------------------------
  real                          :: meanX,meanY,sumXX,sumXY
!-----------------------------------

! From Mathworld least square fitting
! http://mathworld.wolfram.com/LeastSquaresFitting.html

meanX = SUM(x(:))/n
meanY = SUM(y(:))/n

sumXX = DOT_PRODUCT(x,x)-n*meanX**2
sumXY = DOT_PRODUCT(x,y)-n*meanX*meanY

b = sumXY/sumXX

END SUBROUTINE fit_slope

!=============================================================================
SUBROUTINE polyfit(x,y,k,n,coeff)
! """
! DES: Least Square polynomial fitting on x and y
! INP: 
!      x,y   : the input array
!      k     : the order of the polynomial
!      n     : the size of the input array
! OUT: coeff : the coefficient of the polynome
!
! """
!INOUT
  integer                         :: n, k
  real,   dimension(n)            :: x,y
  real,   dimension(k+1)          :: coeff
  !f2py intent(hide),depend(x)    :: n=shape(x)
  !f2py intent(in)                :: x,y,k
  !f2py intent(out)               :: coeff
!-----------------------------------
integer                                       :: I, INFO
double precision, allocatable, dimension(:,:) :: Mat, tMat, InvMat
double precision, allocatable, dimension(:)   :: IPIV, WORK

! From Least Squares Fitting--Polynomial
! http://mathworld.wolfram.com/LeastSquaresFittingPolynomial.html
! need LAPACK to do a matrice inversion

! Tricky memory management to get it running on big arrays...
! use double precision lapack to help the computation
! at most : 2*n*(k+1)+(k+1)**2+4*(k+1)

! Initiate the first matrix X
ALLOCATE(Mat(n,k+1))
DO I=1,k+1
   Mat(:,I) = x(:)**(I-1)
ENDDO

! Save its transposed form
ALLOCATE(tMat(k+1,n))
tMat = TRANSPOSE(Mat)

! The method is based on the inversion of tX.X ...
ALLOCATE(InvMat(k+1,k+1))
InvMat = MATMUL(tMat,Mat)

! ... so inverse it with the help of LAPACK 

! First computes an LU factorization of a general matrix, 
! using partial pivoting with row interchanges.
ALLOCATE(IPIV(k+1))
CALL DGETRF(k+1,k+1,InvMat,k+1,IPIV,INFO)
IF (INFO.ne.0) THEN
   DEALLOCATE(Mat,tMat,InvMat,IPIV)
   PRINT *, "LU factorization failed"
   RETURN
ENDIF

! Then computes the inverse of a general matrix, using the LU
! factorization computed by SGETRF.
ALLOCATE(WORK(3*(k+1)))
CALL DGETRI( k+1, InvMat, k+1, IPIV, WORK, 3*(k+1), INFO )
DEALLOCATE(IPIV,WORK,Mat)

IF (INFO.ne.0) THEN
   DEALLOCATE(tMat,InvMat)
   PRINT *, "Inversing matrix failed"
   RETURN
ENDIF

! Finish the matrix computation need an additionnal Matrix otherwise
! crash - ifc on control, need to be investigated
ALLOCATE(Mat(k+1,n))
Mat = MATMUL(InvMat,tMat)
DEALLOCATE(tMat)

! Finally get the coefficient 
coeff = MATMUL(Mat,y)
DEALLOCATE(InvMat,Mat)

END SUBROUTINE polyfit

! Copyright (C) 2002-2006
! Max-Planck-Institut fuer Radioastronomie Bonn
! Argelander Institut fuer Astronomie
! Astronomisches Institut der Ruhr-Universität Bochum
!
! Produced for the LABOCA project
!
! This library is free software; you can redistribute it and/or modify it under
! the terms of the GNU Library General Public License as published by the Free
! Software Foundation; either version 2 of the License, or (at your option) any
! later version.
!
! This library is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY FITNESS
! FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
! details.
!
! You should have received a copy of the GNU Library General Public License
! along with this library; if not, write to the Free Software Foundation, Inc.,
! 675 Massachusetts Ave, Cambridge, MA 02139, USA.  
!

subroutine safeExp(x,y,n)
! """
! NAM: safeExp (subroutine)
! DES: Attempt to create a fast exponential for python
! """ 
!INOUT ----------------------------
  integer                      :: n
  real, dimension(n)           :: x,y
  !f2py intent(hide),depend(x) :: n = shape(x,0)
  !f2py intent(in)             :: x
  !f2py intent(out)            :: y
!-----------------------------------
!LOCAL
  integer                      :: i
!-----------------------------------

  do i = 1, n
     y(i) = exp(x(i))
  enddo

end subroutine safeExp

subroutine modelBaseEllipticalGaussian(p,n_p,position,n_position,returned_result)
! """
! NAM: modelBase2dgauss (subroutine)
! DES: Compute a model of a 2D gaussian + gradient 
!      (see corresponding python routine)
! """ 
!INOUT ----------------------------
  integer*8                             :: n_p, n_position
  double precision, dimension(n_p)                :: p
  double precision, dimension(n_position)         :: returned_result
  double precision, dimension(2,n_position)       :: position
  !f2py intent(hide),depend(position) :: n_position = shape(position,2)
  !f2py intent(hide),depend(p)        :: n_p = shape(p,0)
  !f2py intent(in)                    :: p, position
  !f2py intent(out)                   :: returned_result
!-----------------------------------
!LOCAL
  integer*8                           :: i
  double precision                    :: pi
  double precision                    :: xp, yp, U
  double precision                    :: fwhm2sigma, sigma_x, sigma_y
!-----------------------------------
  

  fwhm2sigma = 1./(2*sqrt(2.*log(2.)))
  sigma_x = p(7)*fwhm2sigma
  sigma_y = p(8)*fwhm2sigma

  pi = 3.1415926535897931
  
  do i=1,n_position
     xp = (position(1,i)-p(5))*cos(p(9))-(position(2,i)-p(6))*sin(p(9))
     yp = (position(1,i)-p(5))*sin(p(9))+(position(2,i)-p(6))*cos(p(9))
     U = (xp/sigma_x)**2+(yp/sigma_y)**2
     returned_result(i) = p(1)+p(2)*position(1,i)+p(3)*position(2,i)+p(4)*exp(-U/2)
  enddo
    
end subroutine modelBaseEllipticalGaussian

!=============================================================================
subroutine compress(data, flag, flag_value, dataOut, nData, nOut)
! """
! NAM: compress (subroutine)
! DES: compress array based on mask
! INP: data_input (f): 1-D array with data to be returned where flag = flag_value
!      flag       (i): 1-D array, must be same size as data_input
!      flag_value (i): select data where flag=flag_value
! OUT: tuple (x,nData): 1-D array of same size as data_input where first n elements are
!                   those of data_input where flag = flag_value  
! USE: 
!      Unfortunately it is not possible to pass from fortran to python an output
!      array the size of which is computed in fortran. Therefore we must truncate
!      the returned array at the size of the selected true mask elements.
!
!      Example:
!            input_array = array(range(5),'f')
!            flag_array  = array([0,1,0,1,0],'i')
!            compress_array,nmax = f90.f1.compress(input_array,flag_array,1)
!            compress_array = compress_array[0:nmax]
!
! WRN: On input array bigger than 2100000 elements, this function
!      crash because of the f2py interface
! """ 
!-----------------------------------
!INOUT
  integer                          :: nData, nOut
  real,    dimension(nData)        :: data, dataOut
  integer, dimension(nData)        :: flag
  integer, intent(in)              :: flag_value
  !f2py intent(hide),depend(data)  :: nData=shape(data)
  !f2py intent(in)                 :: data
  !f2py intent(hide,out)           :: nOut, dataOut
  
!-----------------------------------
!LOCAL
  logical, dimension(nData)        :: flag_mask   
  integer                          :: mask_true
!-----------------------------------

  flag_mask  = flag.eq.flag_value     ! make a mask
  mask_true  = COUNT(flag_mask)       ! counts the number of TRUE in mask

  if(mask_true>0) then 
     dataOut = PACK(data,MASK=flag_mask)
     nOut    = mask_true
  else
     dataOut = data
     nOut = 0
  end if

end subroutine compress

!=============================================================================
subroutine icompress(data, flag, flag_value, dataOut, nData, nOut)
! """
! NAM: compress (subroutine)
! DES: compress array based on mask
! INP: data_input (i): 1-D array with data to be returned where flag = flag_value
!      flag       (i): 1-D array, must be same size as data_input
!      flag_value (i): select data where flag=flag_value
! OUT: tuple (x,nData): 1-D array of same size as data_input where first n elements are
!                   those of data_input where flag = flag_value  
! USE: 
!      Unfortunately it is not possible to pass from fortran to python an output
!      array the size of which is computed in fortran. Therefore we must truncate
!      the returned array at the size of the selected true mask elements.
!
!      Example:
!            input_array = array(range(5),'f')
!            flag_array  = array([0,1,0,1,0],'i')
!            compress_array,nmax = f90.f1.compress(input_array,flag_array,1)
!            compress_array = compress_array[0:nmax]
! """ 
!-----------------------------------
!INOUT
  integer                          :: nData, nOut
  integer, dimension(nData)        :: data, dataOut
  integer, dimension(nData)        :: flag
  integer, intent(in)              :: flag_value
  !f2py intent(hide),depend(data)  :: nData=shape(data)
  !f2py intent(in)                 :: data
  !f2py intent(hide,out)           :: nOut, dataOut
  
!-----------------------------------
!LOCAL
  logical, dimension(nData)        :: flag_mask   
  integer                          :: mask_true
!-----------------------------------

  flag_mask  = flag.eq.flag_value     ! make a mask
  mask_true  = COUNT(flag_mask)       ! counts the number of TRUE in mask

  if(mask_true>0) then 
     dataOut = PACK(data,MASK=flag_mask)
     nOut    = mask_true
  else
     dataOut = data
     nOut = 0
  end if

end subroutine icompress

!=============================================================================
subroutine ncompress(data, flag, flag_value, dataOut, nData, nOut)
! """
! NAM: compress (subroutine)
! DES: compress array based on mask
! INP: data_input (f): 1-D array with data to be returned where flag != flag_value
!      flag       (i): 1-D array, must be same size as data_input
!      flag_value (i): select data where flag=flag_value
! OUT: tuple (x,nData): 1-D array of same size as data_input where first n elements are
!                   those of data_input where flag = flag_value  
! USE: 
!      Unfortunately it is not possible to pass from fortran to python an output
!      array the size of which is computed in fortran. Therefore we must truncate
!      the returned array at the size of the selected true mask elements.
!
!      Example:
!            input_array = array(range(5),'f')
!            flag_array  = array([0,1,0,1,0],'i')
!            compress_array,nmax = f90.f1.compress(input_array,flag_array,1)
!            compress_array = compress_array[0:nmax]
! """ 
!-----------------------------------
!INOUT
  integer                          :: nData, nOut
  real,    dimension(nData)        :: data, dataOut
  integer, dimension(nData)        :: flag
  integer, intent(in)              :: flag_value
  !f2py intent(hide),depend(data)  :: nData=shape(data)
  !f2py intent(in)                 :: data
  !f2py intent(hide,out)           :: nOut, dataOut
  
!-----------------------------------
!LOCAL
  logical, dimension(nData)        :: flag_mask   
  integer                          :: mask_true
!-----------------------------------

  flag_mask  = flag.ne.flag_value     ! make a mask
  mask_true  = COUNT(flag_mask)       ! counts the number of TRUE in mask

  if(mask_true>0) then 
     dataOut = PACK(data,MASK=flag_mask)
     nOut    = mask_true
  else
     dataOut = data
     nOut = 0
  end if

end subroutine ncompress




!=============================================================================
subroutine replaceNaN(array,nx,ny)
! """
! DES: replace the NaN in a 2D array by a value below 
!      the minimum value of the array
! """ 
!INOUT ----------------------------
  real, dimension(nx,ny)           :: array
  integer                          :: nx,ny
  !f2py intent(hide),depend(array) :: nx = shape(array,0), ny = shape(array,1)
  !f2py intent(in,out)             :: array
!-----------------------------------
!LOCAL
  logical, dimension(nx,ny)        :: mask
  real                             :: min, max
!-----------------------------------

  ! test for the presence of NaN (IEEE x.eq.y should fail for NaN even if x=y=NaN)
  ! for ifc one need to use the -mp1 option for that to work

  mask = array.eq.array

  min = MINVAL(array, mask=mask)
  max = MAXVAL(array, mask=mask)
  
  ! Usualy 255 colors 
  WHERE(array.ne.array) array = min -(max-min)/255

end subroutine replaceNaN

!=============================================================================
subroutine maskNaN(array,mask,nx)
! """
! DES: compute a mask where input 1D array is NaN
! """ 
!INOUT ----------------------------
  real, dimension(nx)              :: array
  integer*4, dimension(nx)         :: mask
  integer                          :: nx
  !f2py intent(hide),depend(array) :: nx = shape(array,0)
  !f2py intent(in)                 :: array
  !f2py intent(out)                :: mask
!-----------------------------------
  mask = array.ne.array
end subroutine maskNaN

!=============================================================================
subroutine MreplaceNaN(array,nx,ny,nz)
! """
! DES: replace the NaN in a 3D array by a value below 
!      the minimum value of the array
! """ 
!INOUT ----------------------------
  real, dimension(nx,ny,nz)        :: array
  integer                          :: nx,ny,nz
  !f2py intent(hide),depend(array) :: nx = shape(array,0), ny = shape(array,1), nz = shape(array,2)
  !f2py intent(in,out)             :: array
!-----------------------------------
!LOCAL
  logical, dimension(nx,ny,nz)     :: mask
  real                             :: min, max
!-----------------------------------

  ! test for the presence of NaN (IEEE x.eq.y should fail for NaN even if x=y=NaN)
  ! for ifc one need to use the -mp1 option for that to work

  mask = array.eq.array

  min = MINVAL(array, mask=mask)
  max = MAXVAL(array, mask=mask)
  
  ! Usualy 255 colors 
  WHERE(array.ne.array) array = min -(max-min)/255

end subroutine MreplaceNaN


subroutine matrixmultiply(m1,m2,prod,n1,nx,n2)
! """
! DES: matrix multiplication 
!     
! """ 
!INOUT ----------------------------
  integer                   :: n1, nx, n2
  double precision, dimension(n1,nx)    :: m1
  double precision, dimension(nx,n2)    :: m2
  double precision, dimension(n1,n2)    :: prod
  !f2py intent(hide),depend(m1)    :: n1=shape(m1,0),nx=shape(m1,1)
  !f2py intent(hide),depend(m2)    :: n2=shape(m2,1)
  !f2py intent(in)                 :: m1,m2
  !f2py intent(out)                :: prod
!-----------------------------------
!LOCAL
 
!-----------------------------------

  prod=matmul(m1,m2)

end subroutine matrixmultiply

! Copyright (C) 2002-2006
! Max-Planck-Institut fuer Radioastronomie Bonn
! Argelander Institut fuer Astronomie
! Astronomisches Institut der Ruhr-Universität Bochum
!
! Produced for the LABOCA project
!
! This library is free software; you can redistribute it and/or modify it under
! the terms of the GNU Library General Public License as published by the Free
! Software Foundation; either version 2 of the License, or (at your option) any
! later version.
!
! This library is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY FITNESS
! FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
! details.
!
! You should have received a copy of the GNU Library General Public License
! along with this library; if not, write to the Free Software Foundation, Inc.,
! 675 Massachusetts Ave, Cambridge, MA 02139, USA.  
!

!=============================================================================
subroutine arrayfitPoly_s(ChanList, Data, DataFlags, Time, Subscans, deg, poly, &
     &nChanList, nChan, nInt, nSubscans )
  ! """
  ! DES: polynomial fit to data with singular value decomposition
  !      using modified routines from Numerical Recipes.
  ! INP: 
  !      ChanList  = make the fit on this channels only
  !      Data      = the entire data array with ...
  !      DataFlags = ... corresponding flags ...
  !      Time      = ... and time, either MJD or LST or whatever
  !      Subscans  = 2d array with starting and ending index of subscans, (python indexed)
  !      deg       = polynom order 
  !
  ! OUT: poly      = the polynomial coefficient by channels and subscans
  !
  ! """
  !INOUT ----------------------------
  integer                                       :: nChan, nInt, deg
  integer, dimension(nChanList)                 :: ChanList
  real,    dimension(nInt,nChan)                :: Data
  integer, dimension(nInt,nChan)                :: DataFlags
  real,    dimension(nInt)                      :: Time
  integer, dimension(2,nSubscans)               :: Subscans
  real,    dimension(nChanList,nSubscans,deg+1) :: poly
  !f2py intent(hide),depend(ChanList)           :: nChanlist = shape(ChanList)
  !f2py intent(hide),depend(Data)               :: nInt = shape(Data,0), nChan = shape(Data,1)
  !f2py intent(hide),depend(Subscans)           :: nSubscans = shape(Subscans)
  !f2py intent(in)                              :: ChanList, Data, DataFlags, Time, Subscans, deg
  !f2py intent(out)                             :: poly
  !LOCAL ----------------------------           
  integer                                       :: iChannel, indexChan
  integer                                       :: iSubscan, startSubscan, endSubscan
  integer                                       :: nGood, subSize
  real                                          :: chisq
  real                                          :: xMax, xMin, yMax, yMin
  logical, allocatable,dimension(:)             :: flag_mask
  integer, allocatable,dimension(:)             :: iDataFlags
  real,    allocatable,dimension(:)             :: iData, iTime
  real,    allocatable,dimension(:)             :: x,y
  real,    dimension(deg+1)                     :: ipoly
  ! ---------------------------------

  DO iChannel=1, nChanList
     ! indexChan in the data/flag array (remember fortran indexing)
     indexChan = ChanList(iChannel)+1

     DO iSubscan=1, nSubscans
        startSubscan = Subscans(1,iSubscan)+1
        endSubscan   = Subscans(2,iSubscan)

        subSize = endSubscan-startSubscan+1

        ALLOCATE(flag_mask(subSize), iDataFlags(subSize), iData(subSize), iTime(subSize))
        
        iDataFlags = DataFlags(startSubscan:endSubscan,indexChan)
        iData      = Data(startSubscan:endSubscan,indexChan)
        iTime      = Time(startSubscan:endSubscan)


        ! find the valid values
        flag_mask = iDataFlags.eq.0
        nGood = COUNT(flag_mask)
        
        ! only fit if the number of good data points is greater than the degree of the polynomial
        IF (nGood>deg) THEN

           ALLOCATE(x(nGood),y(nGood))

           ! reset polynomial coefficient
           ipoly = 0
           
           x = PACK(iTime,MASK=flag_mask) 
           y = PACK(iData,MASK=flag_mask)
           
           call polyfit(x,y,deg,nGood,ipoly)

           poly(iChannel,iSubscan,:) = ipoly

           DEALLOCATE(x,y)

        ENDIF

        DEALLOCATE(flag_mask, iDataFlags, iData, iTime)

     ENDDO
  ENDDO

end subroutine arrayfitPoly_s



!=============================================================================
subroutine subtractPoly(ChanList, Data, Time, Subscans, poly, &
     &nChanList, nChan, nInt, nSubscans, nPoly )
  ! """
  ! DES: polynomial fit to data with singular value decomposition
  !      using modified routines from Numerical Recipes.
  ! INP: 
  !      ChanList  = make the fit on this channels only
  !      Data      = the entire data array with...
  !      Time      = ... time, either MJD or LST or whatever
  !      Subscans  = 2d array with starting and ending index of subscans, (python indexed)
  !      poly      = the polynomial coefficient by channels and subscans
  !
  ! OUT: poly      = the polynomial coefficient by channels and subscans
  !
  ! """
  !INOUT ----------------------------
  integer                                       :: nChanList, nChan, nInt, nSubscan, nPoly
  integer, dimension(nChanList)                 :: ChanList
  real,    dimension(nInt,nChan)                :: Data
  real,    dimension(nInt)                      :: Time
  integer, dimension(2,nSubscans)               :: Subscans
  real,    dimension(nChanList,nSubscans,nPoly) :: poly
  !f2py intent(hide),depend(ChanList)           :: nChanlist = shape(ChanList)
  !f2py intent(hide),depend(Data)               :: nInt = shape(Data,0), nChan = shape(Data,1)
  !f2py intent(hide),depend(Subscans)           :: nSubscans = shape(Subscans)
  !f2py intent(hide),depend(poly)               :: nPoly = shape(poly,2)
  !f2py intent(in)                              :: ChanList, DataFlags, Time, Subscans, poly
  !f2py intent(in,out)                          :: Data
  !LOCAL ----------------------------           
  integer                                       :: iChannel, indexChan
  real,    dimension(nSubscans,nPoly)           :: ipoly
  real,    dimension(nInt)                      :: yFit
  ! ---------------------------------

  DO iChannel=1, nChanList
     ! indexChan in the data/flag array (remember fortran indexing)
     indexChan = ChanList(iChannel)+1

     ipoly = poly(iChannel,:,:)

     ! Evaluate the polynome ... 
     CALL evalChunkedPoly(Time, Subscans, ipoly, yFit, nInt, nSubscans, nPoly)
     
     ! ... and subtract from the data
     Data(:,indexChan) = Data(:,indexChan) - yFit
     
  ENDDO

end subroutine subtractPoly



!=============================================================================
subroutine evalChunkedPoly(x, Chunks, poly, yFit, nX, nChunks, nPoly )
  ! """
  ! DES: evaluate a polynom over several chunks
  ! INP: 
  !      x     = the absciss and ...
  !     Chunks = the start and end index of the chunks (python indexed)
  !      poly  = the polynomial coefficient for the different chunk
  !
  ! OUT:  yFit = the values of the polynomial at x
  !
  ! """
  !INOUT ----------------------------
  integer                            :: nX, nChunks, nPoly
  real,    dimension(nX)             :: x, yFit
  integer, dimension(2,nChunks)      :: Chunks
  real,    dimension(nChunks, nPoly) :: poly
  !f2py intent(hide),depend(X)       :: nX = shape(X)
  !f2py intent(hide),depend(Chunks)  :: nChunks = shape(Chunks,1)
  !f2py intent(hide),depend(poly)    :: nPoly = shape(poly,1)
  !f2py intent(in)                   :: x, Chunks, poly
  !f2py intent(hide,out)             :: yFit
  !LOCAL ----------------------------
  integer                            :: iChunk, start, end, subSize
  real                               :: xMin,xMax, yMin, yMax
  real,    dimension(nPoly)          :: ipoly
  double precision, allocatable, dimension(:)    :: xChunk, yChunk
  ! ---------------------------------

  yFix = 0
  
  DO iChunk=1, nChunks
        start = Chunks(1,iChunk)+1
        end   = Chunks(2,iChunk)

        ! allocate the proper array
        subSize = end-start+1
        ALLOCATE(xChunk(subSize),yChunk(subSize))

        xChunk = x(start:end)
        ipoly = poly(iChunk,:)

        ! Evaluate the polynom ... ( evalPoly is python indexed )
        CALL evalPoly(xChunk, ipoly, yChunk, subSize, nPoly)

        yFit(start:end) = yChunk

        DEALLOCATE(xChunk,yChunk)

     ENDDO

end subroutine evalChunkedPoly




!=============================================================================
subroutine evalPoly(x, poly, y, nX, nPoly )
  ! """
  ! DES: evaluate a polynom 
  ! INP: 
  !      x     = the abcsiss
  !      poly  = the polynomial coefficient
  !
  ! OUT:  y    = the polynomial values at x
  !
  ! """
  !INOUT ----------------------------
  integer                            :: nX
  double precision, dimension(nX)    :: x, y
  real, dimension(nPoly)             :: poly
  !f2py intent(hide),depend(X)       :: nX = shape(X)
  !f2py intent(hide),depend(poly)    :: nPoly = shape(poly)
  !f2py intent(in)                   :: x, poly
  !f2py intent(hide,out)             :: y
  !LOCAL ----------------------------
  integer                            :: i
  ! ---------------------------------

!  Cramer's rule:
  y = 0
  DO i=nPoly,1,-1
     y = y*x+poly(i)
  ENDDO
     
end subroutine evalPoly

! Copyright (C) 2002-2007
! Max-Planck-Institut fuer Radioastronomie Bonn
! Argelander Institut fuer Astronomie
! Astronomisches Institut der Ruhr-Universitaet Bochum
!
! Produced for the LABOCA project
!
! This library is free software; you can redistribute it and/or modify it under
! the terms of the GNU Library General Public License as published by the Free
! Software Foundation; either version 2 of the License, or (at your option) any
! later version.
!
! This library is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY FITNESS
! FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
! details.
!
! You should have received a copy of the GNU Library General Public License
! along with this library; if not, write to the Free Software Foundation, Inc.,
! 675 Massachusetts Ave, Cambridge, MA 02139, USA.  
!$$$$

!=============================================================================
subroutine minmax(array,nx,extrema)
! """
! NAM: minmax
! DES: return maximum and minimum of a 1D array
! """ 
!INOUT ----------------------------
  real, dimension(nx)              :: array
  integer                          :: nx
  real, dimension(2)               :: extrema
  !f2py intent(hide),depend(array) :: nx = shape(array)
  !f2py intent(in)                 :: array
  !f2py intent(out)                :: extrema
!-----------------------------------

  extrema(1) = minval(array)
  extrema(2) = maxval(array)

END SUBROUTINE minmax


!=============================================================================
SUBROUTINE arrayStat_s(data,flag,index_s,mean_s,med_s,sdev_s,mdev_s,nx,ny,ns)
! """
! NAM: arrayStat  (sub)
! DES: compute mean/sdev and median/mdev of a given array sliced by index_s
!      with a given mask (flag=0), along the first dimension 
! INP: data        = entire data array
!      flag        = entire flag array
!      index_s     = the indexes of the subscans
! OUT: mean = 2D float array with the (ny,nz) dimension
!      med  = 2D float array
!      sdev = 2D float array
!      mdev = 2D float array
! """
!-----------------------------------
!INOUT
  integer :: nx,ny,ns
  real,    dimension(nx,ny)          :: data
  integer, dimension(nx,ny)          :: flag
  integer, dimension(2,ns)           :: index_s
  real,    dimension(ny,ns)          :: mean_s, med_s, sdev_s, mdev_s
  !f2py intent(in)                   :: data, flag, index_s
  !f2py intent(hide),depend(flag)    :: nx=shape(flag,0), ny=shape(flag,1)
  !f2py intent(hide),depend(index_s) :: ns=shape(index_s,0)
  !f2py intent(out)                  :: mean_s, med_s, sdev_s, mdev_s
!------------------------------------
!LOCAL
  integer                            :: index, nItem, lo, hi
  real,allocatable,dimension(:,:)    :: tData 
  integer,allocatable,dimension(:,:) :: tFlag
  real, dimension(ny)                :: mean_i, med_i, sdev_i, mdev_i
!------------------------------------

DO index=1,ns        ! loop through the subscans

   lo = index_s(1,index)+1
   hi = index_s(2,index)

   nItem = hi-lo+1

   ALLOCATE(tData(nItem,ny))
   ALLOCATE(tFlag(nItem,ny))

   tData = data(lo:hi,:)
   tFlag = flag(lo:hi,:)

   call arrayStat(tData,tFlag,mean_i,med_i,sdev_i,mdev_i, nItem,ny)
   mean_s(:,index) = mean_i
   med_s(:,index)  = med_i
   sdev_s(:,index) = sdev_i
   mdev_s(:,index) = mdev_i

   DEALLOCATE(tData,tFlag)

END DO

END SUBROUTINE arrayStat_s

!=============================================================================
SUBROUTINE arrayStat(data,flag,mean,med,sdev,mdev,nx,ny)
! """
! NAM: arrayStat  (sub)
! DES: compute mean/sdev and median/median dev of a given 2D array (data) 
!      with a given mask (flag=0), along the first dimension 
! INP: data        = entire data array
!      flag        = entire flag array
! OUT: mean = float array with the second dimension of data
!      med  = float array
!      sdev = float array
!      mdev = float array
! """
!-----------------------------------
!INOUT
  integer :: nx,ny
  real,    dimension(nx,ny)       :: data
  integer, dimension(nx,ny)       :: flag
  real,    dimension(ny)          :: mean,med,sdev,mdev
  !f2py intent(hide),depend(flag) :: nx=shape(flag,0), ny=shape(flag,1)
  !f2py intent(out)               :: mean, med, sdev, mdev
  !f2py intent(in)                :: data,flag
!-----------------------------------
!LOCAL
  integer                         :: index,mask_count
  real                            :: mean_i, med_i, sdev_i, mdev_i
  logical,dimension(nx)           :: flag_mask
  real,allocatable,dimension(:)   :: array
!-----------------------------------

DO index=1,ny        ! loop through channels

   ! take only the 0 flagged data
   flag_mask  = flag(:,index).eq.0
   mask_count = COUNT(flag_mask)
   

   if(mask_count>0) then
      ALLOCATE(array(mask_count))
      array = PACK(data(:,index),MASK=flag_mask)
      CALL f_stat(array,mean_i,sdev_i,med_i,mdev_i,mask_count)
      DEALLOCATE(array)

      mean(index) = mean_i
      sdev(index) = sdev_i
      med(index)  = med_i
      mdev(index) = mdev_i
   else
      mean(index) = -1
      sdev(index) = -1
      med(index)  = -1
      mdev(index) = -1
   end if
      

END DO

END SUBROUTINE arrayStat

!=============================================================================
SUBROUTINE arrayMedian(data,flag,med,nx,ny)
! """
! NAM: arrayMedian  (sub)
! DES: compute median of a given 2D array (data) with a given mask (flag=0),
!      along the first dimension 
! INP: data        = entire data array
!      flag        = entire flag array
! OUT: med = float array with the second dimension of data
! """
!-----------------------------------
!INOUT
  integer :: nx,ny
  real,    dimension(nx,ny)       :: data
  integer, dimension(nx,ny)       :: flag
  real,    dimension(ny)          :: med
  !f2py intent(hide),depend(flag) :: nx=shape(flag,0), ny=shape(flag,1)
  !f2py intent(out)               :: med
  !f2py intent(in)                :: data,flag
!-----------------------------------
!LOCAL
  integer                         :: index,mask_count
  real                            :: med_i
  logical,dimension(nx)           :: flag_mask
  real,allocatable,dimension(:)   :: array
!-----------------------------------

DO index=1,ny        ! loop through channels

   ! take only the 0 flagged data
   flag_mask  = flag(:,index).eq.0
   mask_count = COUNT(flag_mask)
   
   if(mask_count>0) then
      ALLOCATE(array(mask_count))
      array = PACK(data(:,index),MASK=flag_mask)
      CALL f_median(array,med_i,mask_count)
      DEALLOCATE(array)

      med(index)  = med_i
   else
      med(index)  = 0
   end if

END DO

END SUBROUTINE arrayMedian

!=============================================================================
SUBROUTINE arrayMean(data,flag,mean,nx,ny)
! """
! NAM: arrayMean  (sub)
! DES: compute mean of a given 2D array (data) with a given mask (flag=0),
!      along the first dimension 
! INP: data        = entire data array
!      flag        = entire flag array
! OUT: mean = float array with the second dimension of data
! """
!-----------------------------------
!INOUT
  integer :: nx,ny
  real,    dimension(nx,ny)       :: data
  integer, dimension(nx,ny)       :: flag
  real,    dimension(ny)          :: mean
  !f2py intent(hide),depend(flag) :: nx=shape(flag,0), ny=shape(flag,1)
  !f2py intent(out)               :: mean
  !f2py intent(in)                :: data,flag
!-----------------------------------
!LOCAL
  integer                         :: index,mask_count
  real                            :: mean_i
  logical,dimension(nx)           :: flag_mask
  real,allocatable,dimension(:)   :: array
!-----------------------------------

DO index=1,ny        ! loop through channels

   ! take only the 0 flagged data
   flag_mask  = flag(:,index).eq.0
   mask_count = COUNT(flag_mask)
   
   if(mask_count>0) then
      ALLOCATE(array(mask_count))
      array = PACK(data(:,index),MASK=flag_mask)
      CALL f_mean(array,mean_i,mask_count)
      DEALLOCATE(array)

      mean(index)  = mean_i
   else
      mean(index)  = -1
   end if

END DO

END SUBROUTINE arrayMean

!=============================================================================
SUBROUTINE f_stat(data,mean,sdev,med,mdev,i)
! """
! NAM: f_stat  (sub)
! DES: compute mean median, sdev and median dev of a given array
! INP: data         = the data array
! OUT: mean = f scalar
!      med  = f scalar
!      sdev  = f scalar
!      mdef  = f scalar
! """
!-----------------------------------
!INOUT
  integer                          :: i
  real,    dimension(i)            :: data
  real                             :: mean,sdev,med,mdev
  !f2py intent(hide),depend(data)  :: i=shape(data)
  !f2py intent(out)                :: mean,med,sdev,mdev
  !f2py intent(in)                 :: data
!-----------------------------------
!LOCAL
  real,     dimension(i)         :: res,sortedData
!-----------------------------------

  ! need at least two point
  if (i <= 1) then
     mean = -1
     med  = -1
     sdev = -1
     mdef = -1
     return
  end if

  CALL f_mean(data,mean,i)
  CALL f_median(data,med,i)
  CALL f_rms(data,mean,sdev,i)
  CALL f_rms(data,med,mdev,i)

END SUBROUTINE f_stat

!=============================================================================
SUBROUTINE f_mean(data,mean,i)
! """
! NAM: mean (sub)
! DES: compute mean of a given array
! INP: data = the data array
! OUT: mean = f scalar
! """
!-----------------------------------
!INOUT
  integer                          :: i                     
  real,    dimension(i)            :: data
  real                             :: mean
  !f2py intent(hide),depend(data)  :: i=shape(data)
  !f2py intent(in)                 :: data
  !f2py intent(out)                :: mean
!-----------------------------------

  mean = SUM(data(:)) / i

END SUBROUTINE f_mean

!=============================================================================
SUBROUTINE f_rms(data,mean,sdev,i)
! """
! NAM: rms  (sub)
! DES: compute mean and sdev of a given array
! INP: data = the data array
!    : mean = the mean of the data scalar
! OUT: sdev = f scalar
! """
!-----------------------------------
!INOUT
  integer :: i                     
  real,    dimension(i)            :: data
  real                             :: mean,sdev
  !f2py intent(hide),depend(data)  :: i=shape(data)
  !f2py intent(in)                 :: data, mean
  !f2py intent(out)                :: sdev
!-----------------------------------
!LOCAL
  real,     dimension(i)         :: res
!-----------------------------------
  res(:) = data(:) - mean ! these ARE the residuals
  
  ! Variance: Numerically-stable "two-pass" formula, which offers less
  !           round-off error. Page 613, Numerical Recipes in C.
  !sdev = sqrt( ( sum( res(:)*res(:) ) - sum( res(:) )**2 / i) / (i-1) )
  sdev = sqrt( sum( res(:)*res(:) ) / i) 

END SUBROUTINE f_rms

!=============================================================================
SUBROUTINE f_median(data,med,i)
! """
! NAM: median  (sub)
! DES: compute median of a given array
! INP: data         = the data array
! OUT: med = f scalar
! """
!-----------------------------------
!INOUT
  integer                          :: i
  real,    dimension(i)            :: data
  real                             :: med
  !f2py intent(hide),depend(data)  :: i=shape(data)
  !f2py intent(in)                 :: data
  !f2py intent(out)                :: med
!-----------------------------------
!LOCAL
  real,     dimension(i)         :: sortedData
!-----------------------------------
  ! sort the data with the shell method
  call shell(data,sortedData,i)

  if (mod(i,2).eq.0) then
     med = (sortedData(i/2)+sortedData(i/2+1))/2
  else
     med = sortedData((i+1)/2) 
  end if

END SUBROUTINE f_median

!=============================================================================
SUBROUTINE shell(datain,dataout,n)
! """
! NAM: shell  (sub)
! DES: sort an input array with the shell method
!      from N.R. 8.2
! INP: datain   = the input array
! OUT: dataout  = the sorted array
! """
!-----------------------------------
!INOUT
  integer :: n                     ! these must appear in the call parameter list but are hidden
  real,    dimension(n)            :: datain,dataout
  !f2py intent(hide),depend(datain)  :: n=shape(datain)
  !f2py intent(out)                :: dataout
  !f2py intent(in)                 :: datain
!-----------------------------------
!LOCAL
  integer                        :: i,j,inc
  real                           :: v
!-----------------------------------

  dataout = datain

  ! Determine the starting increment
  inc=1
  do while (inc <= n)
     inc=3*inc+1
  end do
  
  do while (inc > 1)
     inc=inc/3
     
     do i=inc+1 ,n
        v=dataout(i)
        j=i
        do
           if (dataout(j-inc) <= v) exit
           dataout(j)=dataout(j-inc)
           j=j-inc
           if (j <= inc) exit
        end do
        dataout(j)=v
     end do
  end do
  
END SUBROUTINE shell

!=============================================================================
SUBROUTINE quickSort(datain,dataout,n)
! """
! NAM: shell  (sub)
! DES: sort an input array with the shell method
!      N.R. 8.1
! INP: datain   = the input array
! OUT: dataout  = the sorted array
! """
!-----------------------------------
!INOUT
  real,    dimension(n)            :: datain,dataout
  integer :: n                     ! these must appear in the call parameter list but are hidden
  !f2py intent(hide),depend(datain)  :: n=shape(datain)
  !f2py intent(out)                :: dataout
  !f2py intent(in)                 :: datain
!-----------------------------------
!LOCAL
  integer                        :: i, j, k, l, r, s, stackl(15), stackr(15), ww
  real                           :: w, x
!-----------------------------------

! modified from http://www.it.uu.se/edu/course/homepage/algpar1/ht02/Quicksort_examples/quicksort.f90

  dataout = datain
  
  s = 1
  stackl(1) = 1
  stackr(1) = n
  
  !     KEEP TAKING THE TOP REQUEST FROM THE STACK UNTIL S = 0.

  DO WHILE (s.NE.0)
     
     l = stackl(s)
     r = stackr(s)
     s = s - 1
     
     !     KEEP SPLITTING DATAOUT(L), ... , DATAOUT(R) UNTIL L >= R.

     DO WHILE (l.LT.r) 
        i = l
        j = r
        k = (l+r) / 2
        x = dataout(k)
        
        !     REPEAT UNTIL I > J.
        
        DO
           DO
              IF (dataout(i).LT.x) THEN                ! Search from lower end
                 i = i + 1
                 CYCLE
              ELSE
                 EXIT
              END IF
           END DO
           
           DO
              IF (x.LT.dataout(j)) THEN                ! Search from upper end
                 j = j - 1
                 CYCLE
              ELSE
                 EXIT
              END IF
           END DO
           
           IF (i.LE.j) THEN                     ! Swap positions i & j
              w = dataout(i)
              dataout(i) = dataout(j)
              dataout(j) = w
              i = i + 1
              j = j - 1
              IF (i.GT.j) EXIT
           ELSE
              EXIT
           END IF
        END DO
        
        IF (j-l.GE.r-i) THEN
           IF (l.LT.j) THEN
              s = s + 1
              stackl(s) = l
              stackr(s) = j
           END IF
           l = i
        ELSE
           IF (i.LT.r) THEN
              s = s + 1
              stackl(s) = i
              stackr(s) = r
           END IF
           r = j
        END IF
        
     END DO
  END DO
  RETURN
  
END SUBROUTINE quickSort

!=============================================================================
SUBROUTINE compress(data,n,datacomp,sdev,i)
! """
! NAM: compress  (sub)
! DES: compress a 1D array over n data
! INP: data = the data array
!    :    n = the number of data point to compress
! OUT: datacomp = the resulting array
!          sdev = the corresponding sdev
! """
!-----------------------------------
!INOUT
  integer :: i                     
  real,    dimension(i)            :: data
  real,    dimension(i/n)          :: datacomp, sdev
  !f2py intent(hide),depend(data)  :: i=shape(data)
  !f2py intent(in)                 :: data, n
  !f2py intent(out)                :: datacomp,sdev
  
  integer :: j
  real    :: iMean, iSdev
  

DO j=0,i/n

   CALL f_mean(data(j*n+1:(j+1)*n+1),iMean,n)
   datacomp(j+1) = iMean
   CALL f_rms(data(j*n+1:(j+1)*n+1),iMean,iSdev,n)
   sdev(j+1)       = iSdev
     
ENDDO

END SUBROUTINE compress


!=============================================================================
SUBROUTINE compressWithFlag(data,flag,n,datacomp,flagcomp,sdev,i)
! """
! NAM: compress  (sub)
! DES: compress a 1D array with flag over n data
! INP: data = the data array
!      flag = the flag array
!    :    n = the number of data point to compress
! OUT: datacomp = resulting data array
!      flagcomp = resulting flag array
!          sdev = corresponding sdev
! """
!-----------------------------------
!INOUT
  integer                          :: i                     
  real,    dimension(i)            :: data
  integer, dimension(i)            :: flag
  real,    dimension(i/n)          :: datacomp, sdev
  integer, dimension(i/n)          :: flagcomp
  !f2py intent(hide),depend(data)  :: i=shape(data)
  !f2py intent(in)                 :: data, flag, n
  !f2py intent(out)                :: datacomp,flagcomp,sdev
  
  integer                           :: j
  real                              :: iMean, iSdev
  real,    allocatable,dimension(:) :: tData
  logical, dimension(n)             :: flag_mask

DO j=0,i/n

   ! take only the 0 flagged data
   flag_mask  = flag(j*n+1:(j+1)*n+1).eq.0
   mask_count = COUNT(flag_mask)
 
   ! we need at least 2 unflagged points
   if(mask_count>1) then
      ALLOCATE(tData(mask_count))

      tData = PACK(data(j*n+1:(j+1)*n+1),MASK=flag_mask)
      CALL f_mean(tData, iMean, mask_count)
      CALL f_rms(tData,iMean,iSdev,mask_count)

      DEALLOCATE(tData)
      
      datacomp(j+1) = iMean
      sdev(j+1)     = iSdev
      flagcomp(j+1) = 0
   else
      datacomp(j+1) = 0
      sdev(j+1)     = 0
      flagcomp(j+1) = -1
   end if
     
ENDDO

END SUBROUTINE compressWithFlag

!=============================================================================
SUBROUTINE arrayCompress(data,flag,n,datacomp,flagcomp,sdev,nx,ny)
! """
! NAM: arrayCompress  (sub)
! DES: compress a 2D array with flag over n data in the first dimension
! INP: data = entire data array
!      flag = entire flag array
!    :    n = the number of data point to compress
! OUT: datacomp = resulting data array
!      flagcomp = resulting flag array
!          sdev = the corresponding sdev
! """
!-----------------------------------
!INOUT
  integer                          :: nx,ny
  real,    dimension(nx,ny)        :: data
  integer, dimension(nx,ny)        :: flag
  real,    dimension(nx/n,ny)      :: datacomp, sdev
  integer, dimension(nx/n,ny)      :: flagcomp
  !f2py intent(hide),depend(flag)  :: nx=shape(flag,0), ny=shape(flag,1)
  !f2py intent(in)                 :: data,flag, n
  !f2py intent(out)                :: datacomp,flagcomp,sdev
  
  integer :: index
  real,    dimension(n)            :: idatacomp, isdev
  integer, dimension(n)            :: iflagcomp
  

DO index=1,ny        ! loop through channels

   CALL compressWithFlag(data(:,index),flag(:,index),n,idatacomp,iflagcomp,isdev,nx)
   datacomp(:,index) = idatacomp
   flagcomp(:,index) = iflagcomp
   sdev(:,index)     = isdev

ENDDO

END SUBROUTINE arrayCompress

!=============================================================================
SUBROUTINE histogram(datain,mini,step,nBin,distrib,n)
! """
! NAM: histogram  (sub)
! DES: return distribution function
! INP: datain   = the input array
!      mini     = lower value
!      step     = bin size
!      nBin     = number of bins
! OUT: distrib  = the histogram values
! """
!-----------------------------------
!INOUT
  integer :: n,nBin
  real    :: mini,step
  real,    dimension(n)            :: datain
  real,    dimension(nBin)         :: distrib
  !f2py intent(hide),depend(datain)  :: n=shape(datain)
  !f2py intent(out)                :: distrib
  !f2py intent(in)                 :: datain,mini,step,nBin
!-----------------------------------
!LOCAL
  integer                     :: i
  real                        :: val1,val2
  logical, dimension(n)       :: mask
!-----------------------------------

  do i=1,nBin
     val1 = mini + (i-1)*step
     val2 = mini + i*step
     mask  = (datain.ge.val1).and.(datain.lt.val2)
     distrib(i) = COUNT(mask)
  end do
  
END SUBROUTINE histogram

!=============================================================================
SUBROUTINE clipping(datain,kappa,dataout,nOut,n)
! """
! NAM: clipping  (sub)
! DES: perform kappa-sigma clipping
! INP: datain   = the input array
!      kappa    = number of sigma for clipping
! OUT: dataout  = the clipped array
! """
!-----------------------------------
!INOUT
  integer                          :: n,nOut
  real                             :: kappa
  real, dimension(n)               :: datain,dataout
  !f2py intent(hide),depend(datain):: n=shape(datain)
  !f2py intent(out)                :: dataout,nOut
  !f2py intent(in)                 :: datain,kappa
!-----------------------------------
!LOCAL
  real                        :: mean,rms
  logical, dimension(n)       :: mask
!-----------------------------------
  CALL f_mean(datain,mean,n)
  CALL f_rms(datain,mean,rms,n)
  mask  = (datain.ge.mean - kappa*rms).and.(datain.le.mean + kappa*rms)
  nOut = COUNT(mask)
  dataout = PACK(datain,MASK=mask)

END SUBROUTINE clipping

!=============================================================================
SUBROUTINE meanDistribution(datain,nbX,nbY,nbTotal,cell,allMean,nbOut,nx,ny)
! """
! NAM: meanDistribution (sub)
! DES: return distribution of means (by cell) in a 2D array
! INP: datain   = the input array
!      kappa    = number of sigma for clipping
! OUT: allMean  = a 1D array of mean values
! """
!-----------------------------------
!INOUT
  integer                            :: nbX,nbY,nbTotal,cell,nx,ny
  real, dimension(nx,ny)             :: datain
  real, dimension(nbTotal)           :: allMean
  !f2py intent(hide),depend(datain)  :: nx=shape(datain,0), ny=shape(datain,1)
  !f2py intent(in)                   :: datain,nbX,nbY,nbTotal,cell
  !f2py intent(out)                  :: allMean,nbOut
!-----------------------------------
!LOCAL
  real                          :: mean
  integer                       :: i,j,k,nOut,nbOut
  real, dimension(cell*cell)    :: subimage,subclean
  logical, dimension(cell*cell) :: mask
  logical, dimension(nbTotal)   :: allmask
!-----------------------------------
  do i=1,nbX
     do j=1,nbY
        do k=0,cell-1
           subimage(k*cell+1:k*cell+cell) = datain(i+1:i+cell,j+k)
        end do
        mask = (subimage.eq.subimage)  ! true if not NaN
        nOut = COUNT(mask)
        if (nOut>0) then
           subclean = PACK(subimage,MASK=mask)
           CALL f_mean(subclean,mean,nOut)
           allMean(j+nbY*(i-1)) = mean
           allmask(j+nbY*(i-1)) = .true.
        else
           allmask(j+nbY*(i-1)) = .false.
        end if
     end do
  end do
  allMean = PACK(allMean,MASK=allmask)
  nbOut = COUNT(allmask)

END SUBROUTINE meanDistribution

!=============================================================================
SUBROUTINE slidingRms(datain,flags,nbInteg,rms,nInt)
! """
! NAM: slidingRms
! DES: return RMS computed over a sliding window
! INP: datain   = the input array
!      flags    = associated flags
!      nbInteg  = size of the sliding window
! OUT: rms      = array of rms, same size as datain
! """
!-----------------------------------
!INOUT
  integer                            :: nInt,nbInteg
  real, dimension(nInt)              :: datain,rms
  integer, dimension(nInt)           :: flags
  !f2py intent(hide),depend(datain)  :: nInt=shape(datain)
  !f2py intent(in)                   :: datain,flags,nbInteg
  !f2py intent(out)                  :: rms
!-----------------------------------
!LOCAL
  integer                          :: half,i,mask_count,first,prev,next
  real,allocatable,dimension(:)    :: tmpData
  logical,allocatable,dimension(:) :: flag_mask
  logical, dimension(nInt)         :: zero_mask
  real                             :: sdev
!-----------------------------------
  half = nbInteg/2
  ! first datapoints until half
  DO i=1,half
     ALLOCATE(flag_mask(i+half))
     flag_mask = flags(1:i+half).eq.0
     mask_count = COUNT(flag_mask)
     ! need at least half/2 points to compute an rms
     IF(mask_count>half/2) then
        ALLOCATE(tmpData(mask_count))
        tmpData = PACK(datain(1:i+half),MASK=flag_mask)
        CALL f_rms(tmpData,0.,sdev,mask_count)
        rms(i) = sdev
        DEALLOCATE(tmpData)
     ELSE
        rms(i) = 0.
     END IF
     DEALLOCATE(flag_mask)
  END DO

  ! datapoints between half and end-half
  ALLOCATE(flag_mask(2*half+1))
  DO i=half+1,nInt-half
     flag_mask = flags(i-half:i+half).eq.0
     mask_count = COUNT(flag_mask)
     IF(mask_count>half/2) then
        ALLOCATE(tmpData(mask_count))
        tmpData = PACK(datain(i-half:i+half),MASK=flag_mask)
        CALL f_rms(tmpData,0.,sdev,mask_count)
        rms(i) = sdev
        DEALLOCATE(tmpData)
     ELSE
        rms(i) = 0.
     END IF
  END DO
  DEALLOCATE(flag_mask)
     
  ! last half datapoints
  DO i=nInt-half+1,nInt
     ALLOCATE(flag_mask(nInt-i+half+1))
     flag_mask = flags(i-half:nInt).eq.0
     mask_count = COUNT(flag_mask)
     ! need at least 3 points to compute an rms
     IF(mask_count>half/2) then
        ALLOCATE(tmpData(mask_count))
        tmpData = PACK(datain(i-half:nInt),MASK=flag_mask)
        CALL f_rms(tmpData,0.,sdev,mask_count)
        rms(i) = sdev
        DEALLOCATE(tmpData)
     ELSE
        rms(i) = 0.
     END IF
     DEALLOCATE(flag_mask)
  END DO

  ! now replace zeros with inter- or extrapolated values
  zero_mask = rms.eq.0.
  mask_count = COUNT(zero_mask)
  IF(mask_count>0) THEN
     i = 1
     IF (zero_mask(1)) THEN
        ! zeros at the start: replace with first non-zero value
        first = 2
        DO WHILE (zero_mask(first))
           first = first+1
        END DO
        rms(1:first-1) = rms(first)
        i = first
     END IF
     DO WHILE (i <= nInt)
        prev = i-1
        DO WHILE (.NOT.(zero_mask(i)).AND.(i <= nInt))
           prev = i
           i = i+1
        END DO
        IF (i <= nInt) THEN
           ! rms(i) is 0
           next = i
           DO WHILE (zero_mask(next).AND.(next < nint))
              next = next+1
           END DO
           IF (next.eq.nInt) THEN
              ! zeros at end: replace with last non-zero
              rms(prev+1:nInt) = rms(prev)
           ELSE
              ! some gap in the middle of the time serie
              DO i=prev+1,next-1
                 rms(i) = rms(prev) + (rms(next)-rms(prev))*(i-prev)/(next-prev)
              END DO
           END IF
           i = next
        END IF
        i = i+1
     END DO
  END IF


END SUBROUTINE slidingRms
